// FDAviInfo.cpp : implementation file
//

#include "stdafx.h"
#include "FDAviInfo.h"
#include "..\eMule.h"
#include "..\otherfunctions.h"

// CFDAviInfo dialog

IMPLEMENT_DYNCREATE(CFDAviInfo, CPropertyPage)

CFDAviInfo::CFDAviInfo() : CPropertyPage(CFDAviInfo::IDD)
, m_bARoundBitrate(FALSE)
{
	//{{AFX_DATA_INIT(CFDAviInfo)
	//}}AFX_DATA_INIT

	m_pFile = NULL;
}

CFDAviInfo::~CFDAviInfo()
{
}

void CFDAviInfo::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFDAviInfo)
	DDX_Control(pDX, IDC_WIDTH_VAL, m_ctrlWidth);
	DDX_Control(pDX, IDC_VIDEOCODEC_VAL, m_ctrlVideoCodec);
	DDX_Control(pDX, IDC_VIDEOBITRATE_VAL, m_ctrlVideoBitrate);
	DDX_Control(pDX, IDC_SAMPLERATE_VAL, m_ctrlSamplerate);
	DDX_Control(pDX, IDC_HEIGHT_VAL, m_ctrlHeight);
	DDX_Control(pDX, IDC_FPS_VAL, m_ctrlFPS);
	DDX_Control(pDX, IDC_CHANNEL_VAL, m_ctrlChannel);
	DDX_Control(pDX, IDC_AUDIOCODEC_VAL, m_ctrlAudioCodec);
	DDX_Control(pDX, IDC_AUDIOBITRATE_VAL, m_ctrlAudioBitrate);
	DDX_Control(pDX, IDC_VIDEO_LBL, m_ctrlVideoLbl);
	DDX_Control(pDX, IDC_PICTURE_LBL, m_ctrlPictureLbl);
	DDX_Control(pDX, IDC_AUDIO_LBL, m_ctrlAudioLbl);
	//}}AFX_DATA_MAP
	DDX_Check(pDX, IDC_ROUNDBITRATE_BTN, m_bARoundBitrate);
	DDX_Control(pDX, IDC_FILESIZE_VAL, m_ctrlFilesize);
	DDX_Control(pDX, IDC_FILELENGTH_VAL, m_ctrlFilelength);
}


BEGIN_MESSAGE_MAP(CFDAviInfo, CPropertyPage)
	//{{AFX_MSG_MAP(CFDAviInfo)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_ROUNDBITRATE_BTN, OnBnClickedRoundbitrateBtn)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFDAviInfo message handlers

BOOL CFDAviInfo::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	m_bARoundBitrate = TRUE;
	CPropertyPage::UpdateData(FALSE);
	Localize();
	Update();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CFDAviInfo::Update()
{
	EMULE_TRY

	if(m_pFile == NULL)
		return;
	
	if(!::IsWindow(GetSafeHwnd()))
		return;

	CFile* pFile = &m_pFile->m_hPartFile;
	try
	{
		TCHAR szTemp[5];
		CString strBuffer;
		uint32 u32;
		uint16 u16;

		if(pFile == NULL)
		{	
			return;
		}
		
		pFile->Seek(8, CFile::begin);
		pFile->Read(szTemp, 4);
		szTemp[4] = 0;
		if(_tcscmp(szTemp, _T("AVI "))) // not avi
		{	
			return;
		}
		
		// filesize
		long lSize;
		pFile->Seek(4, CFile::begin);
		pFile->Read(&lSize, 4);
		strBuffer.Format(_T("%.2f MB"), (static_cast<double>(lSize) / 1024.0 / 1024.0));
		m_ctrlFilesize.SetWindowText(strBuffer);
		
		// header sizes
		long lAviheadersize, lVheadersize;
		pFile->Seek(28, CFile::begin);
		pFile->Read(&lAviheadersize, 4);

		long lAviheaderstart = 32;
		long lVheaderstart = lAviheaderstart + lAviheadersize + 20;

		// misc
		long lMicrosec;
		pFile->Seek(lAviheaderstart, CFile::begin);
		pFile->Read(&lMicrosec, 4);

		long lLengthInFrames;
		pFile->Seek(lAviheaderstart + 16, CFile::begin);
		pFile->Read(&lLengthInFrames, 4);

		// fps
		double dFps = (double)1000000 / (double)lMicrosec;
		strBuffer.Format(_T("%.2f"), dFps);
		m_ctrlFPS.SetWindowText(strBuffer);
				
		// length
		long lLengthInSec = (long)(lLengthInFrames / dFps);
		m_ctrlFilelength.SetWindowText(CastSecondsToHM(lLengthInSec));
		
		// video width
		pFile->Seek(lAviheaderstart + 32, CFile::begin);
		pFile->Read(&u32, 4);
		strBuffer.Format(_T("%d"), u32);
		m_ctrlWidth.SetWindowText(strBuffer);
		
		// video height
		pFile->Seek(lAviheaderstart + 36, CFile::begin);
		pFile->Read(&u32, 4);
		strBuffer.Format(_T("%d"), u32);
		m_ctrlHeight.SetWindowText(strBuffer);
		
		// video codec
		pFile->Seek(lVheaderstart + 4, CFile::begin);
		pFile->Read(szTemp, 4);
		szTemp[4] = 0;
		if(!_tcscmp(szTemp, _T("div3")) || !_tcscmp(szTemp, _T("DIV3")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("DivX 3 Low-Motion"));
		}
		else if(!_tcscmp(szTemp, _T("div4")) || !_tcscmp(szTemp, _T("DIV4")))
		{	
			m_ctrlVideoCodec.SetWindowText(_T("DivX 3 High-Motion"));
		}	
		else if(!_tcscmp(szTemp, _T("divx")) || !_tcscmp(szTemp, _T("DIVX")))
		{	
			m_ctrlVideoCodec.SetWindowText(_T("DivX 4"));
		}
		else if(!_tcscmp(szTemp, _T("DX50")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("DivX 5"));
		}
		else if(!_tcscmp(szTemp, _T("div2")) || !_tcscmp(szTemp, _T("DIV2")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("MS MPEG4 v2"));
		}
		else if(!_tcscmp(szTemp, _T("mp43")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("Microcrap MPEG4 v3"));
		}
		else if(!_tcscmp(szTemp, _T("xvid")) || !_tcscmp(szTemp, _T("XVID")))
		{
			m_ctrlVideoCodec.SetWindowText(_T("XviD"));
		}
		else
		{	
			m_ctrlVideoCodec.SetWindowText(szTemp);
		}
		
		// header sizes
		pFile->Seek(lAviheaderstart + lAviheadersize + 4, CFile::begin);
		pFile->Read(&lVheadersize, 4);

		long lAheaderstart = lVheaderstart + lVheadersize + 8;	//first databyte of audio header

		long lAstrhsize;
		pFile->Seek(lAheaderstart - 4, CFile::begin);
		pFile->Read(&lAstrhsize, 4);

		// audio codec
		pFile->Seek(lAheaderstart + lAstrhsize + 8, CFile::begin);
		pFile->Read(&u16, 2);
		switch(u16)
		{
			case 0:
			case 1:
				m_ctrlAudioCodec.SetWindowText(_T("PCM"));
				break;
			case 353:
				m_ctrlAudioCodec.SetWindowText(_T("DivX;-) Audio"));
				break;
			case 85:
				m_ctrlAudioCodec.SetWindowText(_T("MPEG Layer 3"));
				break;
			case 8192:
				m_ctrlAudioCodec.SetWindowText(_T("AC3-Digital"));
				break;
			default:
				strBuffer.Format(_T("Unknown (%d)"), u16);
				m_ctrlAudioCodec.SetWindowText(strBuffer);
				break;
		}			
			
		// audio channel
		pFile->Seek(lAheaderstart + 2 + lAstrhsize + 8, CFile::begin);
		pFile->Read(&u16, 2);
		switch(u16)
		{
			case 1:
				m_ctrlChannel.SetWindowText(_T("1 (mono)"));
				break;
			case 2:
				m_ctrlChannel.SetWindowText(_T("2 (stereo)"));
				break;
			case 5:
				m_ctrlChannel.SetWindowText(_T("5.1 (surround)"));
				break;
			default:
				strBuffer.Format(_T("%d"), u16);
				m_ctrlChannel.SetWindowText(strBuffer);
				break;
		}
			
		// audio samplerate
		pFile->Seek(lAheaderstart + 4 + lAstrhsize + 8, CFile::begin);
		pFile->Read(&u32, 2);
		strBuffer.Format(_T("%d"), u32);
		m_ctrlSamplerate.SetWindowText(strBuffer);

		// audio bitrate
		pFile->Seek(lAheaderstart + 8 + lAstrhsize + 8, CFile::begin);
		pFile->Read(&m_lAbitrate, 4);
		OnBnClickedRoundbitrateBtn();

		// video bitrate
		strBuffer.Format(_T("%d Kbit/s"), (lSize / lLengthInSec - m_lAbitrate) / 128);
		m_ctrlVideoBitrate.SetWindowText(strBuffer);

	}
	catch(CFileException* error)
	{
		OUTPUT_DEBUG_TRACE();
		error->Delete();	//memleak fix
		return;
	}

	EMULE_CATCH
}

void CFDAviInfo::OnBnClickedRoundbitrateBtn()
{
	EMULE_TRY

	if(m_lAbitrate != 0)
	{
		CPropertyPage::UpdateData();

		if(m_bARoundBitrate)
		{
			long t = m_lAbitrate / (1024 / 8);
			if(t >= 246 && t <= 260)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("256 Kbit/s"));
			}	
			else if(t >= 216 && t <= 228)
			{
				m_ctrlAudioBitrate.SetWindowText(_T("224 Kbit/s"));
			}
			else if(t >= 187 && t <= 196)
			{
				m_ctrlAudioBitrate.SetWindowText(_T("192 Kbit/s"));
			}
			else if(t >= 156 && t <= 164)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("160 Kbit/s"));
			}
			else if(t >= 124 && t <= 132)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("128 Kbit/s"));
			}
			else if(t >= 108 && t <= 116)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("112 Kbit/s"));
			}
			else if(t >= 92 && t <= 100)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("96 Kbit/s"));
			}
			else if(t >= 60 && t <= 68)
			{	
				m_ctrlAudioBitrate.SetWindowText(_T("64 Kbit/s"));
			}
			else
			{
				CString strBuffer;
				strBuffer.Format(_T("%d Kbit/s"), t);
				m_ctrlAudioBitrate.SetWindowText(strBuffer);
			}
		}
		else
		{
			CString strBuffer;
			strBuffer.Format(_T("%d Kbit/s"), m_lAbitrate / (1024 / 8));
			m_ctrlAudioBitrate.SetWindowText(strBuffer);
		}
	}
	else
	{	
		m_ctrlAudioBitrate.SetWindowText(_T(""));
	}

	EMULE_CATCH
}

void CFDAviInfo::Localize()
{
	EMULE_TRY

	if(GetSafeHwnd())
	{
		CString strBuffer;

		GetDlgItem(IDC_PICTURE_LBL)->SetWindowText(GetResString(IDS_FD_PICTURE));
		strBuffer.Format("%s:", GetResString(IDS_WIDTH));
		GetDlgItem(IDC_WIDTH_LBL)->SetWindowText(strBuffer);
		strBuffer.Format("%s:", GetResString(IDS_HEIGHT));
		GetDlgItem(IDC_HEIGHT_LBL)->SetWindowText(strBuffer);
		GetDlgItem(IDC_AUDIO_LBL)->SetWindowText(GetResString(IDS_AUDIO));
		strBuffer.Format("%s:", GetResString(IDS_CODEC));
		GetDlgItem(IDC_AUDIOCODEC_LBL)->SetWindowText(strBuffer);
		strBuffer.Format("%s:", GetResString(IDS_BITRATE));
		GetDlgItem(IDC_AUDIOBITRATE_LBL)->SetWindowText(strBuffer);
		GetDlgItem(IDC_ROUNDBITRATE_BTN)->SetWindowText(GetResString(IDS_ROUNDBITRATE));
		strBuffer.Format("%s:", GetResString(IDS_SAMPLERATE));
		GetDlgItem(IDC_SAMPLERATE_LBL)->SetWindowText(strBuffer);
		strBuffer.Format("%s:", GetResString(IDS_CHANNELS));
		GetDlgItem(IDC_CHANNEL_LBL)->SetWindowText(strBuffer);
		GetDlgItem(IDC_VIDEO_LBL)->SetWindowText(GetResString(IDS_VIDEO));
		strBuffer.Format("%s:", GetResString(IDS_CODEC));
		GetDlgItem(IDC_VIDEOCODEC_LBL)->SetWindowText(strBuffer);
		strBuffer.Format("%s:", GetResString(IDS_BITRATE));
		GetDlgItem(IDC_VIDEOBITRATE_LBL)->SetWindowText(strBuffer);
		strBuffer.Format("%s:", GetResString(IDS_FPS));
		GetDlgItem(IDC_FPS_LBL)->SetWindowText(strBuffer);
		GetDlgItem(IDC_FILESIZE_LBL)->SetWindowText(GetResString(IDS_FD_SIZE));
		strBuffer.Format("%s:", GetResString(IDS_LENGTH));
		GetDlgItem(IDC_FILELENGTH_LBL)->SetWindowText(strBuffer);
	}

	EMULE_CATCH
}
