// PPgServer.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgServer.h"
#include "Inputbox.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


// CPPgServer dialog

IMPLEMENT_DYNAMIC(CPPgServer, CPropertyPage)
CPPgServer::CPPgServer()
	: CPropertyPage(CPPgServer::IDD)
	, removeDead(FALSE)
	, autoServer(FALSE)
	, smartId(FALSE)
	, updateServerConnect(FALSE)
	, filter(FALSE)
	, filterServersByIP(FALSE)
	, autoConnect(FALSE)
	, autoConnectStatic(FALSE)
	, reconnect(FALSE)
	, scoreSystem(FALSE)
	, manualServerHighPriority(FALSE)
	, serverConnectTimeout(_T(""))
	, serverRetries(_T(""))
	, serverKeepAliveTimeout(_T(""))
	, restartWaiting(FALSE)
	, serverConTimeoutDesc(_T(""))
	, srvSecDesc(_T(""))
	, srvMinDesc(_T(""))
	, retriesDesc(_T(""))
	, serverKeepAliveTimeoutDesc(_T(""))
{
}

CPPgServer::~CPPgServer()
{
}

void CPPgServer::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_REMOVEDEAD, removeDead);
	DDX_Check(pDX, IDC_AUTOSERVER, autoServer);
	DDX_Check(pDX, IDC_SMARTIDCHECK, smartId);
	DDX_Check(pDX, IDC_UPDATESERVERCONNECT, updateServerConnect);
	DDX_Check(pDX, IDC_FILTER, filter);
	DDX_Check(pDX, IDC_FILTERSERVERSBYIP, filterServersByIP);
	DDX_Check(pDX, IDC_RESTARTWAITING, restartWaiting);
	DDX_Check(pDX, IDC_AUTOCONNECT, autoConnect);
	DDX_Check(pDX, IDC_AUTOCONNECTSTATICONLY, autoConnectStatic);
	DDX_Check(pDX, IDC_RECONN, reconnect);
	DDX_Check(pDX, IDC_SCORE, scoreSystem);
	DDX_Check(pDX, IDC_MANUALSERVERHIGHPRIO, manualServerHighPriority);
	DDX_Text(pDX, IDC_SRVCONTIMEOUT, serverConnectTimeout);
	DDX_Text(pDX, IDC_SERVERKEEPALIVE, serverKeepAliveTimeout);	
	DDX_Text(pDX, IDC_SERVERRETRIES, serverRetries);	
	DDX_Control(pDX, IDC_SRVCONTIMEOUT, serverConnectTimeoutEdit);
	DDX_Control(pDX, IDC_SERVERKEEPALIVE, serverKeepAliveTimeoutEdit);
	DDX_Control(pDX, IDC_SERVERRETRIES, serverRetriesEdit);
	DDX_Text(pDX, IDC_SRVCONTIMEOUT_LBL, serverConTimeoutDesc);
	DDX_Text(pDX, IDC_SERVERKEEPALIVE_LBL, serverKeepAliveTimeoutDesc);
	DDX_Text(pDX, IDC_SRV_SEC, srvSecDesc);
	DDX_Text(pDX, IDC_SRV_MIN, srvMinDesc);
	DDX_Control(pDX, IDC_REMOVEDEAD, removeDeadCheck);
	DDX_Text(pDX, IDC_RETRIES_LBL, retriesDesc);
	DDX_Control(pDX, IDC_AUTOSERVER, autoServerCheck);
	DDX_Control(pDX, IDC_SMARTIDCHECK, smartIdCheck);
	DDX_Control(pDX, IDC_SCORE, scoreCheck);
	DDX_Control(pDX, IDC_RESTARTWAITING, restartWaitingCheck);
	DDX_Control(pDX, IDC_AUTOCONNECT, autoConnectCheck);
	DDX_Control(pDX, IDC_UPDATESERVERCONNECT, updateServerConnectCheck);
	DDX_Control(pDX, IDC_FILTERSERVERSBYIP, filterServersByIPCheck);
	DDX_Control(pDX, IDC_FILTER, filterCheck);
	DDX_Control(pDX, IDC_RECONN, reconnCheck);
	DDX_Control(pDX, IDC_MANUALSERVERHIGHPRIO, manualSrvHighCheck);
	DDX_Control(pDX, IDC_AUTOCONNECTSTATICONLY, autoConnectStaticCheck);
	DDX_Control(pDX, IDC_ICC_BUTTON, urlsButton);
}

BEGIN_MESSAGE_MAP(CPPgServer, CPropertyPage)
	ON_EN_CHANGE(IDC_SRVCONTIMEOUT, OnEnChangeSrvConTimeout)
	ON_EN_CHANGE(IDC_SERVERRETRIES, OnEnChangeServerretries)
	ON_EN_CHANGE(IDC_SERVERKEEPALIVE, OnEnChangeServerKeepAliveTimeout)
	ON_BN_CLICKED(IDC_AUTOSERVER, OnBnClickedAutoserver)
	ON_BN_CLICKED(IDC_UPDATESERVERCONNECT, OnBnClickedUpdateserverconnect)
	ON_BN_CLICKED(IDC_FILTER, OnBnClickedFilter)
	ON_BN_CLICKED(IDC_SCORE, OnBnClickedScore)
	ON_BN_CLICKED(IDC_REMOVEDEAD, OnBnClickedRemovedead)
	ON_BN_CLICKED(IDC_RESTARTWAITING, OnBnClickedRestartWaiting)
	ON_BN_CLICKED(IDC_SMARTIDCHECK, OnBnClickedSmartIdCheck)
	ON_BN_CLICKED(IDC_AUTOCONNECT, OnBnClickedAutoconnect)
	ON_BN_CLICKED(IDC_RECONN, OnBnClickedReconn)
	ON_BN_CLICKED(IDC_AUTOCONNECTSTATICONLY, OnBnClickedStaticOnly)
	ON_BN_CLICKED(IDC_MANUALSERVERHIGHPRIO, OnBnClickedManualHighPrio)
	ON_BN_CLICKED(IDC_FILTERSERVERSBYIP, OnBnClickedFilterServersByIP)
	ON_BN_CLICKED(IDC_ICC_BUTTON, OnSetURLsForICC)
END_MESSAGE_MAP()

// CPPgServer message handlers

BOOL CPPgServer::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	serverKeepAliveTimeoutEdit.SetLimitText(2);
	serverKeepAliveTimeoutEdit.SetLimitText(2);
	serverRetriesEdit.SetLimitText(2);

	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgServer::LoadSettings(void)
{
	serverConnectTimeout.Format(_T("%d"), m_pPrefs->SrvConTimeout()/1000);		//Cax2 - bugfix for time out - ticks are in milliseconds!!!!!
	serverRetries.Format(_T("%d"), m_pPrefs->GetDeadserverRetries());
	serverKeepAliveTimeout.Format(_T("%d"), m_pPrefs->GetServerKeepAliveTimeout()/60000);

	manualServerHighPriority = m_pPrefs->GetManualHighPrio();
	smartId = m_pPrefs->GetSmartIdCheck();
	removeDead = m_pPrefs->DeadServer();			
	autoServer = m_pPrefs->AutoServerlist();
	updateServerConnect = m_pPrefs->GetAddServersFromConn();
	filter = m_pPrefs->FilterBadIPs();
	filterServersByIP = m_pPrefs->FilterServersByIP();
	scoreSystem = m_pPrefs->Score();
	restartWaiting = m_pPrefs->RestartWaiting();
	reconnect = m_pPrefs->Reconnect();
	autoConnect = m_pPrefs->DoAutoConnect();
	// Barry
	autoConnectStatic = m_pPrefs->AutoConnectStaticOnly();
	
	UpdateData(FALSE);
	OnBnClickedRemovedead();
	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgServer::OnApply()
{	
	if(m_bModified)
	{
		UpdateData(TRUE);	
		
		m_pPrefs->SetDeadServer(removeDead);		
		m_pPrefs->SetSmartIdCheck(smartId);
	
		int sct = _tstoi(serverConnectTimeout);
		if (sct < 10)
			sct = 10;
		else if(sct > 60)
			sct = 60;

		m_pPrefs->SetSrvConTimeout(sct*1000);		//Cax2 - bugfix for time out - ticks are in milliseconds!!!!!
		serverConnectTimeout.Format(_T("%d"),m_pPrefs->SrvConTimeout()/1000);
		
		if(!serverRetries.IsEmpty())
		{
			int sr = _tstoi(serverRetries);
			if (sr == 0)
				sr = 5;
			m_pPrefs->SetDeadserverRetries(sr);
		}
		if(m_pPrefs->GetDeadserverRetries() < 1) 
			m_pPrefs->SetDeadserverRetries(5);

		if(!serverKeepAliveTimeout.IsEmpty())
		{
			int scka = _tstoi(serverKeepAliveTimeout);
			m_pPrefs->SetServerKeepAliveTimeout(scka*60000);
		}
	
		m_pPrefs->SetScore(scoreSystem);
		m_pPrefs->SetAutoServerlist(autoServer);
		m_pPrefs->SetAddServersFromConn(updateServerConnect);
		m_pPrefs->SetFilterBadIPs(filter);
		m_pPrefs->SetFilterServersByIP(filterServersByIP);
		m_pPrefs->SetRestartWaiting(restartWaiting);
	
		m_pPrefs->SetAutoConnect(autoConnect);
		m_pPrefs->SetReconnect(reconnect);
		m_pPrefs->SetManualHighPrio(manualServerHighPriority);

		// Barry
		m_pPrefs->SetAutoConnectStaticOnly(autoConnectStatic);

		SetModified(FALSE);
	}

	return CPropertyPage::OnApply();
}

void CPPgServer::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_SERVER));
		
		serverConTimeoutDesc = GetResString(IDS_SRVCONTIMEOUT_LBL);
		srvSecDesc = GetResString(IDS_SECS);
		removeDeadCheck.SetWindowText(GetResString(IDS_PW_RDEAD));
		retriesDesc = GetResString(IDS_PW_RETRIES);
		serverKeepAliveTimeoutDesc = GetResString(IDS_PW_KEEPALIVE);
		srvMinDesc = GetResString(IDS_MINS);
		updateServerConnectCheck.SetWindowText(GetResString(IDS_PW_USC));		
		filterCheck.SetWindowText(GetResString(IDS_PW_FILTER));
		filterServersByIPCheck.SetWindowText(GetResString(IDS_FILTERSERVERSBYIP));
		autoServerCheck.SetWindowText(GetResString(IDS_PW_USS));
		scoreCheck.SetWindowText(GetResString(IDS_PW_SCORE));		
		restartWaitingCheck.SetWindowText(GetResString(IDS_RESTARTWAITING));	
		smartIdCheck.SetWindowText(GetResString(IDS_SMARTLOWIDCHECK));
		autoConnectCheck.SetWindowText(GetResString(IDS_PW_AUTOCON));
		reconnCheck.SetWindowText(GetResString(IDS_PW_RECON));
		manualSrvHighCheck.SetWindowText(GetResString(IDS_MANUALSERVERHIGHPRIO));		
		autoConnectStaticCheck.SetWindowText(GetResString(IDS_PW_AUTOCONNECTSTATICONLY));
		urlsButton.SetWindowText(GetResString(IDS_ICC_BUTTON));

		UpdateData(FALSE);
	}
}

void CPPgServer::OnBnClickedRemovedead()
{
	UpdateData(TRUE);
	serverRetriesEdit.EnableWindow(removeDead);

	SetModified();
}

void CPPgServer::OnSetURLsForICC()
{
	
	InputBox inputbox;

	inputbox.SetLabels(GetResString(IDS_ICC_INPUTBOX), g_eMuleApp.m_pGlobPrefs->GetURLsForICC());
	inputbox.DoModal();
	if (!inputbox.WasCancelled())
	{
		g_eMuleApp.m_pGlobPrefs->SetURLsForICC(inputbox.GetInput());
		SetModified();
	}
}
