// PPgSorting.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgSorting.h"
#include "ArrowCombo.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// PPgSorting dialog

IMPLEMENT_DYNAMIC(CPPgSorting, CPropertyPage)
CPPgSorting::CPPgSorting()
	: CPropertyPage(CPPgSorting::IDD)
	, bUseSorting(FALSE)
	, bUseSourcesSorting(FALSE)
	, sortServersDesc(_T(""))
	, sortDownloadsDesc(_T(""))
	, sortUploadsDesc(_T(""))
	, sortQueueDesc(_T(""))
	, sortSearchDesc(_T(""))
	, sortIrcDesc(_T(""))
	, sortClientListDesc(_T(""))
	, sortFilesDesc(_T(""))
	, sortSources1Desc(_T(""))
	, sortGrpDesc(_T(""))
{
}

CPPgSorting::~CPPgSorting()
{
}

void CPPgSorting::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SORT_SERVERS, serverColsCombo);
	DDX_Control(pDX, IDC_SORT_FILES, fileColsCombo);
	DDX_Control(pDX, IDC_SORT_DOWNLOADS, downloadColsCombo);
	DDX_Control(pDX, IDC_SORT_UPLOADS, uploadColsCombo);
	DDX_Control(pDX, IDC_SORT_QUEUE, queueColsCombo);
	DDX_Control(pDX, IDC_SORT_SEARCH, searchColsCombo);
	DDX_Control(pDX, IDC_SORT_IRC, ircColsCombo);
	DDX_Control(pDX, IDC_SORT_CLIENTLIST, clientListColsCombo);
	DDX_Control(pDX, IDC_SORT_SOURCES1, sourceCols1Combo);
	DDX_Control(pDX, IDC_SORT_SOURCES2, sourceCols2Combo);
	DDX_Check(pDX, IDC_SORT_USEIT, bUseSorting);
	DDX_Check(pDX, IDC_SORT_SOURCES2_BOX, bUseSourcesSorting);
	DDX_Text(pDX, IDC_SORT_SERVERS_LBL, sortServersDesc);
	DDX_Text(pDX, IDC_SORT_DOWNLOADS_LBL, sortDownloadsDesc);
	DDX_Text(pDX, IDC_SORT_UPLOADS_LBL, sortUploadsDesc);
	DDX_Text(pDX, IDC_SORT_QUEUE_LBL, sortQueueDesc);
	DDX_Text(pDX, IDC_SORT_SEARCH_LBL, sortSearchDesc);
	DDX_Text(pDX, IDC_SORT_IRC_LBL, sortIrcDesc);
	DDX_Text(pDX, IDC_SORT_CLIENTLIST_LBL, sortClientListDesc);
	DDX_Text(pDX, IDC_SORT_FILES_LBL, sortFilesDesc);
	DDX_Text(pDX, IDC_SORT_SOURCES1_LBL, sortSources1Desc);
	DDX_Text(pDX, IDC_SORT_GRP, sortGrpDesc);
	DDX_Control(pDX, IDC_SORT_SOURCES2_BOX, sortSources2Check);
	DDX_Control(pDX, IDC_SORT_USEIT, useItCheck);
}

BEGIN_MESSAGE_MAP(CPPgSorting, CPropertyPage)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SORT_USEIT, OnBnClickedUseSort)
	ON_CBN_SELCHANGE(IDC_SORT_SERVERS, OnCbnSelchangeSortServers)
	ON_CBN_SELCHANGE(IDC_SORT_FILES, OnCbnSelchangeSortFiles)
	ON_CBN_SELCHANGE(IDC_SORT_DOWNLOADS, OnCbnSelchangeSortDownloads)
	ON_CBN_SELCHANGE(IDC_SORT_SOURCES1, OnCbnSelchangeSortSources1)
	ON_CBN_SELCHANGE(IDC_SORT_SOURCES2, OnCbnSelchangeSortSources2)
	ON_CBN_SELCHANGE(IDC_SORT_UPLOADS, OnCbnSelchangeSortUploads)
	ON_CBN_SELCHANGE(IDC_SORT_QUEUE, OnCbnSelchangeSortQueue)
	ON_CBN_SELCHANGE(IDC_SORT_SEARCH, OnCbnSelchangeSortSearch)
	ON_CBN_SELCHANGE(IDC_SORT_IRC, OnCbnSelchangeSortIrc)
	ON_CBN_SELCHANGE(IDC_SORT_CLIENTLIST, OnCbnSelchangeSortClientList)
	ON_BN_CLICKED(IDC_SORT_SOURCES2_BOX, OnBnClickedSortSources2Box)
END_MESSAGE_MAP()

BOOL CPPgSorting::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	LoadSettings();
	Localize();
	return TRUE;
}

void CPPgSorting::LoadSettings(void)
{
	bUseSorting = m_pPrefs->DoUseSort();
	bUseSourcesSorting = m_pPrefs->DoUseSrcSortCol2();

	LoadCombo();
	UpdateData(FALSE);
	OnBnClickedUseSort();
	SetModified(FALSE);
}

BOOL CPPgSorting::OnApply()
{
	if (m_bModified)
	{
		UpdateData(TRUE);

		m_pPrefs->SetUseSort(bUseSorting);
		m_pPrefs->SetUseSrcSortCol2(bUseSourcesSorting);
		m_pPrefs->SetServerSortCol((uint16)serverColsCombo.GetItemData(serverColsCombo.GetCurSel()));
		m_pPrefs->SetUploadSortCol((uint16)uploadColsCombo.GetItemData(uploadColsCombo.GetCurSel()));
		m_pPrefs->SetQueueSortCol((uint16)queueColsCombo.GetItemData(queueColsCombo.GetCurSel()));
		m_pPrefs->SetSearchSortCol((uint16)searchColsCombo.GetItemData(searchColsCombo.GetCurSel()));
		m_pPrefs->SetIrcSortCol((uint16)ircColsCombo.GetItemData(ircColsCombo.GetCurSel()));
		m_pPrefs->SetClientListSortCol((uint16)clientListColsCombo.GetItemData(clientListColsCombo.GetCurSel()));
		m_pPrefs->SetFileSortCol((uint16)fileColsCombo.GetItemData(fileColsCombo.GetCurSel()));
		m_pPrefs->SetDownloadSortCol((uint16)downloadColsCombo.GetItemData(downloadColsCombo.GetCurSel()));
		m_pPrefs->SetSrcSortCol1((uint16)sourceCols1Combo.GetItemData(sourceCols1Combo.GetCurSel()));
		m_pPrefs->SetSrcSortCol2((uint16)sourceCols2Combo.GetItemData(sourceCols2Combo.GetCurSel()));

		SetModified();

		if (m_pPrefs->DoUseSort())
		{
			g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.SortInit(m_pPrefs->GetServerSortCol());
			g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlUploadList.SortInit(m_pPrefs->GetUploadSortCol());
			g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlQueueList.SortInit(m_pPrefs->GetQueueSortCol());
			g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlClientList.SortInit(m_pPrefs->GetClientListSortCol());
			g_eMuleApp.m_pdlgEmule->m_dlgSearch.m_ctlSearchList.SortInit(m_pPrefs->GetSearchSortCol());
			g_eMuleApp.m_pdlgEmule->m_wndIRC.SortInit(m_pPrefs->GetIrcSortCol());
			g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.m_ctlSharedFilesList.SortInit(m_pPrefs->GetFileSortCol());
			SetModified(FALSE); //needs the settings for downloadlistcontrol
			g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlDownloadList.SortInit(DL_OVERRIDESORT); //major override...
			g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlDownloadList.SortInit(true); //normal override, in case we show sources...
			g_eMuleApp.m_pdlgEmule->m_dlgSearch.m_ctlSearchList.SetLastSortCode(m_pPrefs->GetSearchSortCol());
		}
	}

	return CPropertyPage::OnApply();
}

void CPPgSorting::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_SORTING));
		useItCheck.SetWindowText(GetResString(IDS_SORT_USEIT));
		sortServersDesc = GetResString(IDS_SORT_SERVERS_LBL);
		sortDownloadsDesc = GetResString(IDS_SORT_DOWNLOADS_LBL);
		sortUploadsDesc = GetResString(IDS_SORT_UPLOADS_LBL);
		sortQueueDesc = GetResString(IDS_SORT_QUEUE_LBL);
		sortSearchDesc = GetResString(IDS_SORT_SEARCH_LBL);
		sortFilesDesc = GetResString(IDS_SORT_FILES_LBL);
		sortIrcDesc = GetResString(IDS_SORT_IRC_LBL);
		sortClientListDesc = GetResString(IDS_SORT_CLIENTLIST_LBL);

		sortGrpDesc = GetResString(IDS_SORT_GRP);
		sortSources1Desc = GetResString(IDS_SORT_SOURCES1_LBL);
		sortSources2Check.SetWindowText(GetResString(IDS_SORT_SOURCES2_LBL));

		LoadCombo();

		UpdateData(FALSE);
	}
}

void CPPgSorting::OnBnClickedSortSources2Box()
{
	UpdateData(TRUE);

	sourceCols2Combo.EnableWindow(bUseSourcesSorting);

	SetModified();
}

void CPPgSorting::OnBnClickedUseSort()
{
	UpdateData(TRUE);

	serverColsCombo.EnableWindow(bUseSorting);
	fileColsCombo.EnableWindow(bUseSorting);
	downloadColsCombo.EnableWindow(bUseSorting);
	uploadColsCombo.EnableWindow(bUseSorting);
	queueColsCombo.EnableWindow(bUseSorting);
	searchColsCombo.EnableWindow(bUseSorting);
	ircColsCombo.EnableWindow(bUseSorting);
	clientListColsCombo.EnableWindow(bUseSorting);
	sourceCols1Combo.EnableWindow(bUseSorting);
	sourceCols2Combo.EnableWindow(bUseSorting);
	if(bUseSorting)
		sourceCols2Combo.EnableWindow(bUseSourcesSorting);
	else
		sourceCols2Combo.EnableWindow(bUseSorting);

	SetModified();
}

void CPPgSorting::LoadCombo(void)
{
	serverColsCombo.ResetContent();
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SL_SERVERNAME)+_T("[^]")),0);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SL_SERVERNAME)),0+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_IP)+_T("[^]")),1);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_IP)),1+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_DESCRIPTION)+_T("[^]")),2);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_DESCRIPTION)),2+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PING)+_T("[^]")),3);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PING)),3+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_UUSERS)+_T("[^]")),4);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_UUSERS)),4+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_MAXUSERS)+_T("[^^]")),4+MLC_SORTALT);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_MAXUSERS)+_T("[vv]")),4+MLC_SORTALT+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PW_FILES)+_T("[^]")),5);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PW_FILES)),5+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PRIORITY)+_T("[^]")),6);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_PRIORITY)),6+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_UFAILED)+_T("[^]")),7);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_UFAILED)),7+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_STATICSERVER)+_T("[^]")),8);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_STATICSERVER)),8+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_SOFTLIMIT)+_T("[^]")),9);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_SOFTLIMIT)),9+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_HARDLIMIT)+_T("[^^]")),9+MLC_SORTALT);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_HARDLIMIT)+_T("[vv]")),9+MLC_SORTALT+MLC_SORTDESC);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_VERSION)+_T("[^]")),10);
	serverColsCombo.SetItemData(serverColsCombo.AddString(GetResString(IDS_SERVER_VERSION)),10+MLC_SORTDESC);

	fileColsCombo.ResetContent();
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_DL_FILENAME)+_T("[^]")),0);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_DL_FILENAME)),0+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_DL_SIZE)+_T("[^]")),1);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_DL_SIZE)),1+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_TYPE)+_T("[^]")),2);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_TYPE)),2+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_PRIORITY)+_T("[^]")),3);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_PRIORITY)),3+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_PERMISSION)+_T("[^]")),4);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_PERMISSION)),4+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_FILEID)+_T("[^]")),5);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_FILEID)),5+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_REQUESTS)+_T("[^]")),6);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_REQUESTS)),6+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_REQUESTS)+_T("[^^]")),6+MLC_SORTALT);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_REQUESTS)+_T("[vv]")),6+MLC_SORTALT+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_ACCEPTS)+_T("[^]")),7);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_ACCEPTS)),7+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_ACCEPTS)+_T("[^^]")),7+MLC_SORTALT);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_ACCEPTS)+_T("[vv]")),7+MLC_SORTALT+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_TRANSFERRED)+_T("[^]")),8);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_TRANSFERRED)),8+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_TRANSFERRED)+_T("[^^]")),8+MLC_SORTALT);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_TRANSFERRED)+_T("[vv]")),8+MLC_SORTALT+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_PARTTRAFFIC)+_T("[^]")),9);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_PARTTRAFFIC)),9+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_PARTTRAFFIC)+_T("[^^]")),9+MLC_SORTALT);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_PARTTRAFFIC)+_T("[vv]")),9+MLC_SORTALT+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COLUPLOADS)+_T("[^]")),10);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COLUPLOADS)),10+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COLUPLOADS)+_T("[^^]")),10+MLC_SORTALT);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COLUPLOADS)+_T("[vv]")),10+MLC_SORTALT+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COMPLETESRC)+_T("[^]")),11);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COMPLETESRC)),11+MLC_SORTDESC);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COMPLETESRC)+_T("[^^]")),11+MLC_SORTALT);
	fileColsCombo.SetItemData(fileColsCombo.AddString(GetResString(IDS_SF_COMPLETESRC)+_T("[vv]")),11+MLC_SORTALT+MLC_SORTDESC);

	uploadColsCombo.ResetContent();
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_QL_USERNAME)+_T("[^]")),0);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_QL_USERNAME)),0+MLC_SORTDESC);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_FILE)+_T("[^]")),1);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_FILE)),1+MLC_SORTDESC);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_SPEED)+_T("[^]")),2);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_SPEED)),2+MLC_SORTDESC);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_TRANSF)+_T("[^]")),3);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_TRANSF)),3+MLC_SORTDESC);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_WAITED)+_T("[^]")),4);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_WAITED)),4+MLC_SORTDESC);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_UPLOADTIME)+_T("[^]")),5);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_UPLOADTIME)),5+MLC_SORTDESC);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_STATUS)+_T("[^]")),6);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_STATUS)),6+MLC_SORTDESC);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_UP_PARTS)+_T("[^]")),7);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_UP_PARTS)),7+MLC_SORTDESC);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_PROGRESS)+_T("[^]")),8);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_DL_PROGRESS)),8+MLC_SORTDESC);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_COMPRESSION)+_T("[^]")),9);
	uploadColsCombo.SetItemData(uploadColsCombo.AddString(GetResString(IDS_COMPRESSION)),9+MLC_SORTDESC);

	queueColsCombo.ResetContent();
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_QL_USERNAME)+_T("[^]")),0);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_QL_USERNAME)),0+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_FILE)+_T("[^]")),1);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_FILE)),1+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_FILEPRIO)+_T("[^]")),2);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_FILEPRIO)),2+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_UP_PARTS)+_T("[^]")),3);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_UP_PARTS)),3+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_DL_PROGRESS)+_T("[^]")),4);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_DL_PROGRESS)),4+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_QL_RATING)+_T("[^]")),5);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_QL_RATING)),5+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_SCORE)+_T("[^]")),6);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_SCORE)),6+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_SFRATIO)+_T("[^]")),7);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_SFRATIO)),7+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_RFRATIO)+_T("[^]")),8);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_RFRATIO)),8+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_ASKED)+_T("[^]")),9);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_ASKED)),9+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_LASTSEEN)+_T("[^]")),10);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_LASTSEEN)),10+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_ENTERQUEUE)+_T("[^]")),11);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_ENTERQUEUE)),11+MLC_SORTDESC);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_BANNED)+_T("[^]")),12);
	queueColsCombo.SetItemData(queueColsCombo.AddString(GetResString(IDS_BANNED)),12+MLC_SORTDESC);

	searchColsCombo.ResetContent();
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_FILENAME)+_T("[^]")),0);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_FILENAME)),0+MLC_SORTDESC);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_SIZE)+_T("[^]")),1);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_SIZE)),1+MLC_SORTDESC);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_SOURCES)+_T("[^]")),2);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_DL_SOURCES)),2+MLC_SORTDESC);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_TYPE)+_T("[^]")),3);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_TYPE)),3+MLC_SORTDESC);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_FILEID)+_T("[^]")),4);
	searchColsCombo.SetItemData(searchColsCombo.AddString(GetResString(IDS_FILEID)),4+MLC_SORTDESC);

	ircColsCombo.ResetContent();
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_IRC_NAME)+_T("[^]")),0);
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_IRC_NAME)),0+MLC_SORTDESC);
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_UUSERS)+_T("[^]")),1);
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_UUSERS)),1+MLC_SORTDESC);
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_DESCRIPTION)+_T("[^]")),2);
	ircColsCombo.SetItemData(ircColsCombo.AddString(GetResString(IDS_DESCRIPTION)),2+MLC_SORTDESC);

	CString colsoft;
	CString connected;
	colsoft=GetResString(IDS_CD_CSOFT);
	connected=GetResString(IDS_CONNECTED);
	colsoft.Remove(':');
	connected.Remove(':');

	clientListColsCombo.ResetContent();
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(GetResString(IDS_QL_USERNAME)+_T("[^]")),0);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(GetResString(IDS_QL_USERNAME)),0+MLC_SORTDESC);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(GetResString(IDS_CL_UPLOADSTATUS)+_T("[^]")),1);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(GetResString(IDS_CL_UPLOADSTATUS)),1+MLC_SORTDESC);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(GetResString(IDS_CL_TRANSFUP)+_T("[^]")),2);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(GetResString(IDS_CL_TRANSFUP)),2+MLC_SORTDESC);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(GetResString(IDS_CL_DOWNLSTATUS)+_T("[^]")),3);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(GetResString(IDS_CL_DOWNLSTATUS)),3+MLC_SORTDESC);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(GetResString(IDS_CL_TRANSFDOWN)+_T("[^]")),4);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(GetResString(IDS_CL_TRANSFDOWN)),4+MLC_SORTDESC);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(colsoft+_T("[^]")),5);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(colsoft),5+MLC_SORTDESC);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(connected+_T("[^]")),6);
	clientListColsCombo.SetItemData(clientListColsCombo.AddString(connected),6+MLC_SORTDESC);

	downloadColsCombo.ResetContent();
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_FILENAME)+_T("[^]")),0);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_FILENAME)),0+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SIZE)+_T("[^]")),1);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SIZE)),1+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_TRANSF)+_T("[^]")),2);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_TRANSF)),2+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_SF_COMPLETED)+_T("[^]")),3);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_SF_COMPLETED)),3+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SPEED)+_T("[^]")),4);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SPEED)),4+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_PROGRESS)+_T("[^]")),5);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_PROGRESS)),5+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SOURCES)+_T("[^]")),6);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_SOURCES)),6+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_PRIORITY)+_T("[^]")),7);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_PRIORITY)),7+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_STATUS)+_T("[^]")),8);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_STATUS)),8+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_REMAINS)+_T("[^]")),9);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DL_REMAINS)),9+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_TIME)+_T("[^]")),10);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_TIME)),10+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_INFLST_FILE_LASTSEENCOMPLETE)+_T("[^]")),13);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_INFLST_FILE_LASTSEENCOMPLETE)),13+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_FD_LASTCHANGE)+_T("[^]")),14);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_FD_LASTCHANGE)),14+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_CAT)+_T("[^]")),15);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_CAT)),15+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_WAITED)+_T("[^]")),DLCOL_WAITED);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_WAITED)),DLCOL_WAITED+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DLCOL_AVGSPEED)+_T("[^]")),DLCOL_AVGSPEED);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DLCOL_AVGSPEED)),DLCOL_AVGSPEED+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DLCOL_AVGREMTIME)+_T("[^]")),DLCOL_AVGREMTIME);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DLCOL_AVGREMTIME)),DLCOL_AVGREMTIME+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DLCOL_ETA)+_T("[^]")),DLCOL_ETA);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DLCOL_ETA)),DLCOL_ETA+MLC_SORTDESC);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DLCOL_AVGETA)+_T("[^]")),DLCOL_AVGETA);
	downloadColsCombo.SetItemData(downloadColsCombo.AddString(GetResString(IDS_DLCOL_AVGETA)),DLCOL_AVGETA+MLC_SORTDESC);

	sourceCols1Combo.ResetContent();
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_QL_USERNAME)+_T("[^]")),0);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_QL_USERNAME)),0+MLC_SORTDESC);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_TRANSF)+_T("[^]")),2);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_TRANSF)),2+MLC_SORTDESC);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_SF_COMPLETED)+_T("[^]")),3);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_SF_COMPLETED)),3+MLC_SORTDESC);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_SPEED)+_T("[^]")),4);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_SPEED)),4+MLC_SORTDESC);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_PROGRESS)+_T("[^]")),5);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_PROGRESS)),5+MLC_SORTDESC);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_INFLST_USER_CLIENTSOFTWARE)+_T("[^]")),6);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_INFLST_USER_CLIENTSOFTWARE)),6+MLC_SORTDESC);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(_T("QR[^]")),7);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(_T("QR")),7+MLC_SORTDESC);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_STATUS)+_T("[^]")),8);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_STATUS)),8+MLC_SORTDESC);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_ULDL)+_T("[^]")),11);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_DL_ULDL)),11+MLC_SORTDESC);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_QL_RATING)+_T("[^]")),12);
	sourceCols1Combo.SetItemData(sourceCols1Combo.AddString(GetResString(IDS_QL_RATING)),12+MLC_SORTDESC);

	sourceCols2Combo.ResetContent();
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_SORT_DEFAULT)),DL_DEFAULTSOURCESORT);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_QL_USERNAME)+_T("[^]")),0);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_QL_USERNAME)),0+MLC_SORTDESC);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_TRANSF)+_T("[^]")),2);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_TRANSF)),2+MLC_SORTDESC);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_SF_COMPLETED)+_T("[^]")),3);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_SF_COMPLETED)),3+MLC_SORTDESC);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_SPEED)+_T("[^]")),4);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_SPEED)),4+MLC_SORTDESC);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_PROGRESS)+_T("[^]")),5);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_PROGRESS)),5+MLC_SORTDESC);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_INFLST_USER_CLIENTSOFTWARE)+_T("[^]")),6);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_INFLST_USER_CLIENTSOFTWARE)),6+MLC_SORTDESC);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(_T("QR[^]")),7);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(_T("QR")),7+MLC_SORTDESC);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_STATUS)+_T("[^]")),8);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_STATUS)),8+MLC_SORTDESC);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_ULDL)+_T("[^]")),11);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_DL_ULDL)),11+MLC_SORTDESC);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_QL_RATING)+_T("[^]")),12);
	sourceCols2Combo.SetItemData(sourceCols2Combo.AddString(GetResString(IDS_QL_RATING)),12+MLC_SORTDESC);


	sourceCols2Combo.EnableWindow(bUseSourcesSorting);

	int i;
	int gc;

	serverColsCombo.SetCurSel(0);
	gc = serverColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(serverColsCombo.GetItemData(i) == m_pPrefs->GetServerSortCol()) {
			serverColsCombo.SetCurSel(i);
			break;
		}

	fileColsCombo.SetCurSel(0);
	gc = fileColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(fileColsCombo.GetItemData(i) == m_pPrefs->GetFileSortCol()) {
			fileColsCombo.SetCurSel(i);
			break;
		}

	downloadColsCombo.SetCurSel(0);
	gc = downloadColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(downloadColsCombo.GetItemData(i) == m_pPrefs->GetDownloadSortCol()) {
			downloadColsCombo.SetCurSel(i);
			break;
		}

	uploadColsCombo.SetCurSel(0);
	gc = uploadColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(uploadColsCombo.GetItemData(i) == m_pPrefs->GetUploadSortCol()) {
			uploadColsCombo.SetCurSel(i);
			break;
		}

	queueColsCombo.SetCurSel(0);
	gc = queueColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(queueColsCombo.GetItemData(i) == m_pPrefs->GetQueueSortCol()) {
			queueColsCombo.SetCurSel(i);
			break;
		}

	searchColsCombo.SetCurSel(0);
	gc = searchColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(searchColsCombo.GetItemData(i) == m_pPrefs->GetSearchSortCol()) {
			searchColsCombo.SetCurSel(i);
			break;
		}

	ircColsCombo.SetCurSel(0);
	gc = ircColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(ircColsCombo.GetItemData(i) == m_pPrefs->GetIrcSortCol()) {
			ircColsCombo.SetCurSel(i);
			break;
		}

	clientListColsCombo.SetCurSel(0);
	gc = clientListColsCombo.GetCount();
	for(i = 0; i != gc; i++)
		if(clientListColsCombo.GetItemData(i) == m_pPrefs->GetClientListSortCol()) {
			clientListColsCombo.SetCurSel(i);
			break;
		}

	sourceCols1Combo.SetCurSel(0);
	gc = sourceCols1Combo.GetCount();
	for(i = 0; i != gc; i++)
		if(sourceCols1Combo.GetItemData(i) == m_pPrefs->GetSrcSortCol1()) {
			sourceCols1Combo.SetCurSel(i);
			break;
		}

	sourceCols2Combo.SetCurSel(0);
	gc = sourceCols2Combo.GetCount();
	for(i = 0; i != gc; i++)
		if(sourceCols2Combo.GetItemData(i) == m_pPrefs->GetSrcSortCol2()) {
			sourceCols2Combo.SetCurSel(i);
			break;
		}
}
