// PPgWindow.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgWindow.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgWindow dialog

IMPLEMENT_DYNAMIC(CPPgWindow, CPropertyPage)
CPPgWindow::CPPgWindow()
	: CPropertyPage(CPPgWindow::IDD)
	, startMin(FALSE)
	, minTray(FALSE)
	, closeToTray(FALSE)
	, promptOnExit(FALSE)
	, bringToForeground(FALSE)
	, showRateOnTitle(FALSE)
	, showSpeedMeterOnToolbar(FALSE)
	, showA4AF(FALSE)
	, showAvgDataRate(FALSE)
	, showFileTypeIcons(FALSE)
	, showTransferredOnCompleted(FALSE)
	, showDownloadPercentage(FALSE)
	, showPausedGray(FALSE)
	, showFileStatusIcons(FALSE)
	, usedFontDesc(_T(""))
{
}

CPPgWindow::~CPPgWindow()
{
}

void CPPgWindow::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_STARTMIN, startMin);
	DDX_Check(pDX, IDC_MINTRAY, minTray);
	DDX_Check(pDX, IDC_CB_TBN_CLOSETOTRAY, closeToTray);
	DDX_Check(pDX, IDC_EXIT, promptOnExit);
	DDX_Check(pDX, IDC_BRINGTOFOREGROUND, bringToForeground);
	DDX_Check(pDX, IDC_SHOWRATEONTITLE, showRateOnTitle);
	DDX_Check(pDX, IDC_TBSPEEDMETER, showSpeedMeterOnToolbar);
	DDX_Check(pDX, IDC_A4AF, showA4AF);
	DDX_Check(pDX, IDC_SHOWAVGDATARATE, showAvgDataRate);
	DDX_Check(pDX, IDC_SHOWFTYPE, showFileTypeIcons);
	DDX_Check(pDX, IDC_SHOWTRANFONCMPLT, showTransferredOnCompleted);
	DDX_Check(pDX, IDC_SHOWDWLPERCENTAGE, showDownloadPercentage);
	DDX_Check(pDX, IDC_SHOWGRAY, showPausedGray);
	DDX_Check(pDX, IDC_STATUSICONS, showFileStatusIcons);
	DDX_Text(pDX, IDC_USEDFONT_LBL, usedFontDesc);
	DDX_Control(pDX, IDC_USEDFONT, fontPreviewCombo);
	DDX_Control(pDX, IDC_USEDFONTSIZE, fontSizeCombo);
	DDX_Control(pDX, IDC_STARTMIN, startMinCheck);
	DDX_Control(pDX, IDC_MINTRAY, minTrayCheck);
	DDX_Control(pDX, IDC_CB_TBN_CLOSETOTRAY, closeToTrayCheck);
	DDX_Control(pDX, IDC_EXIT, promptOnExitCheck);
	DDX_Control(pDX, IDC_BRINGTOFOREGROUND, bringToForegroundCheck);
	DDX_Control(pDX, IDC_SHOWRATEONTITLE, showRateOnTitleCheck);
	DDX_Control(pDX, IDC_TBSPEEDMETER, showSpeedMeterOnToolbarCheck);
	DDX_Control(pDX, IDC_A4AF, showA4AFCheck);
	DDX_Control(pDX, IDC_SHOWAVGDATARATE, showAvgDataRateCheck);
	DDX_Control(pDX, IDC_SHOWFTYPE, showFileTypeIconsCheck);
	DDX_Control(pDX, IDC_SHOWTRANFONCMPLT, showTransferredOnCompletedCheck);
	DDX_Control(pDX, IDC_SHOWDWLPERCENTAGE, showDownloadPercentageCheck);
	DDX_Control(pDX, IDC_SHOWGRAY, showPausedGrayCheck);
	DDX_Control(pDX, IDC_STATUSICONS, showFileStatusIconsCheck);
}

BEGIN_MESSAGE_MAP(CPPgWindow, CPropertyPage)
	ON_BN_CLICKED(IDC_STARTMIN, OnEnChangeStartMin)
	ON_BN_CLICKED(IDC_MINTRAY, OnBnClickedMintray)
	ON_BN_CLICKED(IDC_EXIT, OnBnClickedExit)
	ON_BN_CLICKED(IDC_BRINGTOFOREGROUND, OnBnClickedBringtoforeground)
	ON_BN_CLICKED(IDC_CB_TBN_CLOSETOTRAY, OnBnClickedCbTbnClosetotray)
	ON_CBN_SELCHANGE(IDC_USEDFONT, OnCbnSelchangeUsedFont)
	ON_CBN_SELCHANGE(IDC_USEDFONTSIZE, OnCbnSelchangeUsedfontsize)
	ON_BN_CLICKED(IDC_SHOWRATEONTITLE, OnBnClickedShowRateOnTitle)
	ON_BN_CLICKED(IDC_TBSPEEDMETER, OnBnClickedSpeedMeter)
	ON_BN_CLICKED(IDC_A4AF, OnBnClickedA4AF)
	ON_BN_CLICKED(IDC_SHOWAVGDATARATE, OnBnClickedAvgDataRate)
	ON_BN_CLICKED(IDC_SHOWFTYPE, OnBnClickedShowFileType)
	ON_BN_CLICKED(IDC_SHOWTRANFONCMPLT, OnBnClickedTransferredOnCompleted)
	ON_BN_CLICKED(IDC_SHOWDWLPERCENTAGE, OnBnClickedDownloadPercentage)
	ON_BN_CLICKED(IDC_SHOWGRAY, OnBnClickedShowPausedGray)
	ON_BN_CLICKED(IDC_STATUSICONS, OnBnClickedShowFileStatusIcons)
END_MESSAGE_MAP()

BOOL CPPgWindow::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	fontPreviewCombo.m_style = CFontPreviewCombo::NAME_ONLY;
	fontPreviewCombo.Init();

	fontSizeCombo.AddString(_T("8"));
	fontSizeCombo.AddString(_T("10"));
	fontSizeCombo.AddString(_T("12"));
	LoadSettings();
	Localize();

	return TRUE;
}

void CPPgWindow::LoadSettings(void)
{
	startMin = m_pPrefs->GetStartMinimized();		
	minTray = m_pPrefs->DoMinToTray();
	promptOnExit = m_pPrefs->IsConfirmExitEnabled();
	bringToForeground = m_pPrefs->IsBringToFront();
	closeToTray = m_pPrefs->GetCloseToTray();	
	showRateOnTitle = m_pPrefs->ShowRatesOnTitle();		
	showSpeedMeterOnToolbar = m_pPrefs->GetShowToolbarSpeedMeter();
	showA4AF = m_pPrefs->IsA4AFStringEnabled();
	showAvgDataRate = m_pPrefs->GetShowAverageDataRate();
	showFileTypeIcons = m_pPrefs->ShowFileTypeIcon();
	showTransferredOnCompleted = m_pPrefs->IsTransferredOnCompleted();
	showDownloadPercentage = m_pPrefs->GetUseDwlPercentage();
	showPausedGray = m_pPrefs->ShowPausedGray();
	showFileStatusIcons = m_pPrefs->ShowFullFileStatusIcons();
	
	int FontIdx = fontPreviewCombo.FindStringExact(0,m_pPrefs->GetUsedFont());
	if(FontIdx == LB_ERR)
       fontPreviewCombo.SetCurSel(0);
	else
       fontPreviewCombo.SetCurSel(FontIdx);
	fontSizeCombo.SetCurSel(0);
	if (m_pPrefs->GetFontSize())
		fontSizeCombo.SetCurSel((int)((m_pPrefs->GetFontSize()-80)/20)); // FontSize Cax2

	UpdateData(FALSE);

	SetModified(FALSE);	// FoRcHa
}

BOOL CPPgWindow::OnApply()
{
	if(m_bModified)
	{
		UpdateData(TRUE);
		
		int8 mintotray_old = m_pPrefs->DoMinToTray(); // #zegzav (add)
		int8 ShowFileTypeIcon_old = m_pPrefs->ShowFileTypeIcon(); // DonGato

		m_pPrefs->SetStartMinimized(startMin);
		m_pPrefs->SetMinToTray(minTray);
		m_pPrefs->SetConfirmExitEnabled(promptOnExit);
		m_pPrefs->SetBringToFront(bringToForeground);
		m_pPrefs->SetCloseToTray(closeToTray);
		m_pPrefs->SetRatesOnTitle(showRateOnTitle);
		m_pPrefs->SetShowToolbarSpeedMeter(showSpeedMeterOnToolbar);
		m_pPrefs->SetA4AFStringEnabled(showA4AF);
		m_pPrefs->SetShowAverageDataRate(showAvgDataRate);
		m_pPrefs->SetShowFileTypeIcon(showFileTypeIcons);
		m_pPrefs->SetTransferredOnCompleted(showTransferredOnCompleted);
		m_pPrefs->SetUseDwlPercentage(showDownloadPercentage);
		m_pPrefs->SetShowPausedGray(showPausedGray);
		m_pPrefs->SetShowFullFileStatusIcons(showFileStatusIcons);

		// #zegzav
        if (mintotray_old != (int8)m_pPrefs->DoMinToTray())
		{
            g_eMuleApp.m_pdlgEmule->TraySetMinimizeToTray((int8)m_pPrefs->DoMinToTray());
    		g_eMuleApp.m_pdlgEmule->TrayMinimizeToTrayChanged();
        }
   
		// DonGato
        if (ShowFileTypeIcon_old != (int8)m_pPrefs->ShowFileTypeIcon())
		{
            g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlDownloadList.Invalidate();
            g_eMuleApp.m_pdlgEmule->m_wndSharedFiles.m_ctlSharedFilesList.Invalidate();
        }

		CString buffer;
		fontPreviewCombo.GetWindowText(buffer);
		m_pPrefs->SetUsedFont(buffer);
		m_pPrefs->SetFontSize(fontSizeCombo.GetCurSel()*20 + 80);	// FontSize Cax2
		// Cax2 - Font update
		g_eMuleApp.m_pdlgEmule->m_fontDefault.DeleteObject(); 
		g_eMuleApp.m_pdlgEmule->m_fontDefault.CreatePointFont(m_pPrefs->GetFontSize(),buffer); 
      	g_eMuleApp.m_pdlgEmule->m_wndServer.InitFont(); 
      	g_eMuleApp.m_pdlgEmule->m_wndIRC.InitFont(); 
      	g_eMuleApp.m_pdlgEmule->m_wndChat.chatselector.chatout.SetFont(&g_eMuleApp.m_pdlgEmule->m_fontDefault); 

		g_eMuleApp.m_pdlgEmule->m_wndTransfer.m_ctlDownloadList.SetStyle();
		g_eMuleApp.m_pdlgEmule->m_ctlToolBar.ShowSpeedMeter(m_pPrefs->GetShowToolbarSpeedMeter());

		SetModified(FALSE);

		if (!g_eMuleApp.m_pGlobPrefs->ShowRatesOnTitle()) {
			CString buffer;
			buffer.Format(_T("eMule Plus v%s"),CURRENT_VERSION_LONG);
			g_eMuleApp.m_pdlgEmule->SetWindowText(buffer);
		}
	}

	return CPropertyPage::OnApply();
}

void CPPgWindow::Localize(void)
{
	if(::IsWindow(m_hWnd))
	{
		SetWindowText(GetResString(IDS_PW_WINDOW));
		startMinCheck.SetWindowText(GetResString(IDS_PREF_STARTMIN));	
		minTrayCheck.SetWindowText(GetResString(IDS_PW_TRAY));
		promptOnExitCheck.SetWindowText(GetResString(IDS_PW_PROMPT));
		bringToForegroundCheck.SetWindowText(GetResString(IDS_PW_FRONT));
		closeToTrayCheck.SetWindowText(GetResString(IDS_PW_TBN_CLOSETOTRAY));
		usedFontDesc = GetResString(IDS_USEDFONT_LBL);
		showRateOnTitleCheck.SetWindowText(GetResString(IDS_SHOWRATEONTITLE));
		showSpeedMeterOnToolbarCheck.SetWindowText(GetResString(IDS_PW_SHOWTOOLBARSPEEDMETER));
		showA4AFCheck.SetWindowText(GetResString(IDS_A4AF));
		showAvgDataRateCheck.SetWindowText(GetResString(IDS_SHOWAVGDATARATE));
		showFileTypeIconsCheck.SetWindowText(GetResString(IDS_SHOWFTYPE));
		showTransferredOnCompletedCheck.SetWindowText(GetResString(IDS_SHOWTRANFONCMPLT));
		showDownloadPercentageCheck.SetWindowText(GetResString(IDS_SHOWDWLPERCENTAGE));
		showPausedGrayCheck.SetWindowText(GetResString(IDS_SHOWGRAY));
		showFileStatusIconsCheck.SetWindowText(GetResString(IDS_STATUSICONS));
		UpdateData(FALSE);
	}
}
