//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


//	ServerListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "ServerListCtrl.h"
//#include "Sockets/EmEngine.h"
#include "otherfunctions.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#define new DEBUG_NEW
#endif

//	CServerListCtrl

IMPLEMENT_DYNAMIC(CServerListCtrl, CMuleListCtrl /*CTreeCtrl*/)

//#region message map
BEGIN_MESSAGE_MAP(CServerListCtrl, CMuleListCtrl /*CTreeCtrl*/)
//	ON_NOTIFY_REFLECT(NM_RCLICK, OnNMRclickServlist)
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnLvnColumnclickServlist)
	ON_NOTIFY_REFLECT (NM_DBLCLK, OnNMLdblclk)
	ON_WM_CONTEXTMENU()
	ON_WM_DESTROY()
END_MESSAGE_MAP()
//#endregion

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CServerListCtrl::CServerListCtrl()
{
	memset2(&m_bSortAscending, 0, 13);
	m_pServerList = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CServerListCtrl::Init(CServerList *pServerList)
{
	ModifyStyle(0, TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS);
//	Set Imagelist
	m_pServerList = pServerList;
	m_imageList.Create(16, 16, ILC_COLOR32 | ILC_MASK, 0, 10);
	m_imageList.SetBkColor(CLR_NONE);
	m_imageList.Add(LoadImgLstIcon(MAKEINTRESOURCE(IDI_SMALLSERVER), 16, 16));
	LoadImgLstIcon(NULL, 0, 0);

	SetImageList(&m_imageList, LVSIL_SMALL); //TVSIL_NORMAL);
	ModifyStyle(LVS_SINGLESEL | LVS_LIST | LVS_ICON | LVS_SMALLICON, LVS_REPORT); //here the CListCtrl is set to report-style
	SetExtendedStyle(LVS_EX_FULLROWSELECT);

	InsertColumn(0, GetResString(IDS_SL_SERVERNAME), LVCFMT_LEFT, 150);
	InsertColumn(1, GetResString(IDS_IP), LVCFMT_LEFT, 140);
	InsertColumn(2, GetResString(IDS_DESCRIPTION) , LVCFMT_LEFT, 150);
	InsertColumn(3, GetResString(IDS_PING), LVCFMT_RIGHT, 50);

	CString	strTemp;

	strTemp.Format(_T("%s (%s)"), GetResString(IDS_UUSERS), GetResString(IDS_MAXUSERS));
	InsertColumn(4, strTemp, LVCFMT_RIGHT, 50);
	InsertColumn(5, GetResString(IDS_FILES) , LVCFMT_RIGHT, 50);
	InsertColumn(6, GetResString(IDS_PRIORITY), LVCFMT_LEFT, 60);
	InsertColumn(7, GetResString(IDS_UFAILED), LVCFMT_RIGHT, 50);
	InsertColumn(8, GetResString(IDS_STATICSERVER), LVCFMT_LEFT, 50);
	InsertColumn(9, GetResString(IDS_SERVER_SOFTHARDLIMIT), LVCFMT_RIGHT, 100);
	InsertColumn(10, GetResString(IDS_SERVER_VERSION), LVCFMT_LEFT, 150);

	m_bSortAscending[4] = true;
	m_bSortAscending[5] = true;
	m_bSortAscending[7] = true;
	m_bSortAscending[9] = true;
	m_bSortAscending[10] = true;

	LoadSettings(CPreferences::TABLE_SERVER);

	if (g_eMuleApp.m_pGlobPrefs->DoUseSort())
	{
		SortInit(g_eMuleApp.m_pGlobPrefs->GetServerSortCol());
	}
	else
	{
		int	iSortColumn = g_eMuleApp.m_pGlobPrefs->GetColumnSortItem(CPreferences::TABLE_SERVER);
		bool	bSortAscending = g_eMuleApp.m_pGlobPrefs->GetColumnSortAscending(CPreferences::TABLE_SERVER);

		SortInit(iSortColumn | (bSortAscending ? MLC_SORTASC : MLC_SORTDESC));
	}

	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CServerListCtrl::~CServerListCtrl()
{}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerListCtrl::OnDestroy()
{
	m_imageList.DeleteImageList();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerListCtrl::SortInit(int iSortCode)
{
//	Get the sort column
	int		iSortColumn = (iSortCode & MLC_COLUMNMASK);
//	Get the sort order
	bool	bSortAscending = (iSortCode & MLC_SORTDESC) == 0;
//	Get the alternate sort
	int		iSortAltFlag = (iSortCode & MLC_SORTALT);

	m_bSortAscending[iSortColumn] = bSortAscending;
	if (iSortAltFlag == 0)
		SetSortArrow(iSortColumn, bSortAscending);
	else
		SetSortArrow(iSortColumn, m_bSortAscending[iSortColumn] ? arrowDoubleUp : arrowDoubleDown);
	SortItems(&SortProc, iSortCode);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerListCtrl::Localize()
{
	if (GetSafeHwnd())
	{
		CHeaderCtrl	* pHeaderCtrl = GetHeaderCtrl();
		HDITEM	hdi;

		hdi.mask = HDI_TEXT;

		CString	strRes;

		strRes = GetResString(IDS_SL_SERVERNAME);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(0, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_IP);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(1, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_DESCRIPTION);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(2, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_PING);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(3, &hdi);
		strRes.ReleaseBuffer();


		strRes.Format(_T("%s (%s)"), GetResString(IDS_UUSERS), GetResString(IDS_MAXUSERS));
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(4, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_FILES);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(5, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_PRIORITY);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(6, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_UFAILED);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(7, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_STATICSERVER);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(8, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SERVER_SOFTHARDLIMIT);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(9, &hdi);
		strRes.ReleaseBuffer();

		strRes = GetResString(IDS_SERVER_VERSION);
		hdi.pszText = strRes.GetBuffer();
		pHeaderCtrl->SetItem(10, &hdi);
		strRes.ReleaseBuffer();

		for (POSITION pos = m_pServerList->m_serverList.GetHeadPosition(); pos != NULL;)
		{
			CServer*	pServer = m_pServerList->m_serverList.GetNext(pos);
			int			iIndex = FindIndex(pServer);

			if (iIndex != -1)
				RefreshServerDesc(iIndex, *pServer);
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CServerListCtrl::FindIndex(const CServer *pServer) const
{

	LVFINDINFO	find;

	::ZeroMemory(&find, sizeof(LVFINDINFO));
	find.flags = LVFI_PARAM;
	find.lParam = (LPARAM)pServer;

	return FindItem(&find);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	RefreshServerDesc() refreshes the server description for the 'iIndex'th server from 'server'.
void CServerListCtrl::RefreshServerDesc(int iIndex, const CServer &server)
{

	CString	strTemp;

	strTemp.Format(_T("%s : %i"), server.GetAddress(), server.GetPort());
	SetItemText(iIndex, 1, strTemp);
	if (server.GetListName())
	{
		SetItemText(iIndex, 0, server.GetListName());
	}
	if (server.GetDescription())
	{
		SetItemText(iIndex, 2, server.GetDescription());
	}
	if (server.GetPing())
	{
		strTemp.Format(_T("%i"), server.GetPing());
		SetItemText(iIndex, 3, strTemp);
	}
	if (server.GetNumUsers())
	{
		if (server.GetMaxUsers())
			strTemp.Format(_T("%i (%i)"), server.GetNumUsers(), server.GetMaxUsers());
		else
			strTemp.Format(_T("%i"), server.GetNumUsers());
		SetItemText(iIndex, 4, strTemp);
	}
	if (server.GetFiles())
	{
		strTemp.Format(_T("%i"), server.GetFiles());
		SetItemText(iIndex, 5, strTemp);
	}
	switch (server.GetPreferences())
	{
		case PR_LOW:
		{
			SetItemText(iIndex, 6, GetResString(IDS_PRIOLOW));
			break;
		}
		case PR_NORMAL:
		{
			SetItemText(iIndex, 6, GetResString(IDS_PRIONORMAL));
			break;
		}
		case PR_HIGH:
		{
			SetItemText(iIndex, 6, GetResString(IDS_PRIOHIGH));
			break;
		}
		default:
		{
			SetItemText(iIndex, 6, GetResString(IDS_PRIONOPREF));
		}
	}

	strTemp.Format(_T("%i"), server.GetFailedCount());
	SetItemText(iIndex, 7, strTemp);

	if (server.IsStaticMember())
		SetItemText(iIndex, 8, GetResString(IDS_YES));
	else
		SetItemText(iIndex, 8, GetResString(IDS_NO));

	if (server.GetHardMaxFiles())
	{
		if (server.GetSoftMaxFiles())
			strTemp.Format(_T("%i (%i)"), server.GetSoftMaxFiles(), server.GetHardMaxFiles());
		else
			strTemp.Format(_T("(%i)"), server.GetHardMaxFiles());
		SetItemText(iIndex, 9, strTemp);
	}

	SetItemText(iIndex, 10, server.GetVersion());
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerListCtrl::RemoveServer(CServer *pServer, bool bDelToList)
{
	int	iIndex = FindIndex(pServer);

	if (iIndex != -1)
	{
		m_pServerList->RemoveServer(GetServerAt(iIndex));
		DeleteItem(iIndex);
	}
	ShowFilesCount();
	return;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Remove Dead Servers
void CServerListCtrl::RemoveDeadServer()
{
	if (g_eMuleApp.m_pGlobPrefs->DeadServer())
	{
		ShowWindow(SW_HIDE);

#ifndef USE_SAFE_ARRAY

		for (POSITION pos = m_pServerList->m_serverList.GetHeadPosition(); pos != NULL; m_pServerList->m_serverList.GetNext(pos))
		{
			CServer	* pServer = m_pServerList->m_serverList.GetAt(pos);

			if ( pServer->GetFailedCount() > g_eMuleApp.m_pGlobPrefs->GetDeadserverRetries()
			     && !pServer->IsStaticMember() )
			{
				RemoveServer(pServer);
				pos = m_pServerList->m_serverList.GetHeadPosition();
			}
		}
#else
		for (INT_PTR pos = 0; pos < m_pServerList->array.GetCount(); pos++)
		{
			CServer	*pServer = m_pServerList->GetServerAt(pos);

			if ( pServer->GetFailedCount() > g_eMuleApp.m_pGlobPrefs->GetDeadserverRetries()
				 && !pServer->IsStaticMember() )
			{
				RemoveServer(pServer);
				pos = 0;
			}
		}
#endif
		ShowWindow(SW_SHOW);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerListCtrl::AppendServer(CServer *pServer)
{

	if (::IsWindow(GetSafeHwnd()))
	{
		int	iNumServers = GetItemCount();
		int	iIndex = 0;

		iIndex = InsertItem( LVIF_TEXT | LVIF_PARAM, iNumServers, pServer->GetListName(), 0, 0, 1,
							reinterpret_cast<LPARAM>(pServer) );
		if (pServer->GetFailedCount() < 0)
			pServer->ResetFailedCount();
		RefreshServerDesc(iIndex, *pServer);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CServerListCtrl::AddServer(CServer *pServer, bool bAddToList, bool bBulkLoad)
{
	if (pServer == NULL)
		return false;

	if (!m_pServerList->AddServer(pServer))
		return false;

	if (bAddToList)
		AppendServer(pServer);
	if (!bBulkLoad)
		ShowFilesCount();
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerListCtrl::RefreshServer(CServer &server)
{
	if (!::IsWindow(m_hWnd))
		return;

	int	iIndex = FindIndex(&server);

	if (iIndex == -1)
		return;

	if (server.GetFailedCount() < 0)
		server.ResetFailedCount();
	RefreshServerDesc(iIndex, server);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//	CServerListCtrl message handlers

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerListCtrl::OnContextMenu(CWnd *pWnd, CPoint point)
{
//	On right click, we also want to change the current selection like the left click does
	CPoint	p = point;

	ScreenToClient(&p);

	int	iIndex = HitTest(p);

	if (iIndex != -1)
		SetSelectionMark(iIndex);

//	Create up-to-date popupmenu
	UINT	iMenuFlags;
	CTitleMenu	m_ServerMenu;
	CMenu	m_ServerPrioMenu;
	CServer	*pServer = NULL;

	if (GetSelectionMark() != -1)
		pServer = GetSelectedServer();

//	Set state of selection-dependent menuitems
	iMenuFlags = MF_STRING || MF_DISABLED;
	if (GetSelectionMark() != ( -1) && GetSelectedCount() > 0)
	{
		if (pServer != NULL)
			iMenuFlags = MF_STRING;
	}

	m_ServerPrioMenu.CreateMenu();
	m_ServerPrioMenu.AppendMenu(MF_STRING, MP_PRIOLOW, GetResString(IDS_PRIOLOW));
	m_ServerPrioMenu.AppendMenu(MF_STRING, MP_PRIONORMAL, GetResString(IDS_PRIONORMAL));
	m_ServerPrioMenu.AppendMenu(MF_STRING, MP_PRIOHIGH, GetResString(IDS_PRIOHIGH));

	m_ServerMenu.CreatePopupMenu();
	m_ServerMenu.AddMenuTitle(GetResString(IDS_EM_SERVER));
	m_ServerMenu.AppendMenu(iMenuFlags, MP_CONNECTTO, GetResString(IDS_CONNECTTHIS));
	m_ServerMenu.AppendMenu(iMenuFlags | MF_POPUP, (UINT_PTR)m_ServerPrioMenu.m_hMenu, GetResString(IDS_PRIORITY));

//	Hide greyed-out "add /remove from static server"
	if (pServer != NULL && GetSelectedCount() > 0)
	{
		if (pServer->IsStaticMember())
			m_ServerMenu.AppendMenu(iMenuFlags, MP_REMOVEFROMSTATIC, GetResString(IDS_REMOVEFROMSTATIC));
		else
			m_ServerMenu.AppendMenu(iMenuFlags, MP_ADDTOSTATIC, GetResString(IDS_ADDTOSTATIC));
	}

	m_ServerMenu.AppendMenu(MF_STRING | MF_SEPARATOR);
	m_ServerMenu.AppendMenu(iMenuFlags, MP_REMOVE, GetResString(IDS_REMOVETHIS));
	m_ServerMenu.AppendMenu(MF_STRING, MP_REMOVEALL, GetResString(IDS_REMOVEALL));
	m_ServerMenu.AppendMenu(MF_SEPARATOR);
	m_ServerMenu.AppendMenu(iMenuFlags, MP_GETED2KLINK, GetResString(IDS_DL_LINK1));

	m_ServerMenu.SetDefaultItem(MP_CONNECTTO);
	m_ServerMenu.TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);

	m_ServerPrioMenu.DestroyMenu();
	m_ServerMenu.DestroyMenu();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CServerListCtrl::OnCommand(WPARAM wParam, LPARAM lParam)
{
	int	iIndex = GetSelectionMark();

	if (wParam == MP_REMOVEALL)
	{
#ifdef OLD_SOCKETS_ENABLED
		if (g_eMuleApp.m_pServerConnect->IsConnecting())
		{
			g_eMuleApp.m_pDownloadQueue->StopUDPRequests();
			g_eMuleApp.m_pServerConnect->StopConnectionTry();
			g_eMuleApp.m_pServerConnect->Disconnect();
			g_eMuleApp.m_pdlgEmule->ShowConnectionState(false);
		}
#endif //OLD_SOCKETS_ENABLED
		ShowWindow(SW_HIDE);
		m_pServerList->RemoveAllServers();
		DeleteAllItems();
		ShowWindow(SW_SHOW);
		ShowFilesCount();
		return true;
	}

	if (iIndex != -1)
	{
		if (GetSelectedServer() != NULL)
		{
			switch (wParam)
			{
			//#region Connect To Server
				case MP_CONNECTTO:
				{
					if (GetSelectedCount() > 1)
					{
						CServer	* pServer;
#ifdef OLD_SOCKETS_ENABLED

						g_eMuleApp.m_pServerConnect->Disconnect();
#endif OLD_SOCKETS_ENABLED

						POSITION	pos = GetFirstSelectedItemPosition();

					//	Move selected servers to the start of the list, to connect them first
						while (pos != NULL)
						{
							iIndex = GetNextSelectedItem(pos);
							if (iIndex > -1)
							{
								pServer = GetServerAt(iIndex);
								g_eMuleApp.m_pServerList->MoveServerDown(pServer);
							}
						}
#ifdef OLD_SOCKETS_ENABLED
						g_eMuleApp.m_pServerConnect->ConnectToAnyServer((g_eMuleApp.m_pServerList->GetServerCount() - GetSelectedCount()), false);
#else OLD_SOCKETS_ENABLED

						g_eMuleApp.m_pEngine->ConnectToAnyServer();
#endif OLD_SOCKETS_ENABLED

					}
					else
					{
#ifdef OLD_SOCKETS_ENABLED
						if (g_eMuleApp.m_pServerConnect->IsConnected())
						{
							if ( !_tcscmp( GetSelectedServer()->GetAddress(),
							               g_eMuleApp.m_pServerConnect->GetCurrentServer()->GetAddress() ) )
							{
								AddLogLine(false, IDS_ALREADYCONNECTED, GetSelectedServer()->GetListName());
								break;
							}
						}
						g_eMuleApp.m_pServerConnect->ConnectToServer(*GetSelectedServer());
#endif OLD_SOCKETS_ENABLED
#ifdef NEW_SOCKETS

						CServer	*pServer = GetSelectedServer();

						if (pServer != NULL)
							g_eMuleApp.m_pEngine->ConnectToServer(pServer);
#endif NEW_SOCKETS

					}
					g_eMuleApp.m_pdlgEmule->ShowConnectionState(false);
					break;
				}
			//#endregion
			//#region Remove Server
				case MP_REMOVE:
				{
					ShowWindow(SW_HIDE);

					POSITION	pos;

					while (GetFirstSelectedItemPosition() != NULL)
					{
						pos = GetFirstSelectedItemPosition();
						iIndex = GetNextSelectedItem(pos);
						m_pServerList->RemoveServer(GetServerAt(iIndex));
						DeleteItem(iIndex);
					}
					ShowFilesCount();
					ShowWindow(SW_SHOW);
					break;
				}
			//#endregion
			//#region Add to Static Server List
				case MP_ADDTOSTATIC:
				{
					POSITION	pos = GetFirstSelectedItemPosition();

					while (pos != NULL)
					{
						CServer	* pServer = GetServerAt(GetNextSelectedItem(pos));

						if (!StaticServerFileAppend(pServer))
							return false;
						pServer->SetIsStaticMember(true);
						g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshServer(*pServer);
					}
					break;
				}
			//#endregion
			//#region Remove from Static Server List
				case MP_REMOVEFROMSTATIC:
				{
					POSITION	pos = GetFirstSelectedItemPosition();

					while (pos != NULL)
					{
						CServer	* pServer = GetServerAt(GetNextSelectedItem(pos));

						if (!StaticServerFileRemove(pServer))
							return false;
						pServer->SetIsStaticMember(false);
						g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshServer(*pServer);
					}
					break;
				}
			//#endregion
			//#region Set Server Priority to "Low"
				case MP_PRIOLOW:
				{
					POSITION	pos = GetFirstSelectedItemPosition();

					while (pos != NULL)
					{
						CServer	* pServer = GetServerAt(GetNextSelectedItem(pos));

						pServer->SetPreference(CServer::SERVERPRIORITY_LOW);
						if (pServer->IsStaticMember())
							StaticServerFileAppend(pServer);
						g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshServer(*pServer);
					}
					break;
				}
			//#endregion
			//#region Set Server Priority to "Normal"
				case MP_PRIONORMAL:
				{
					POSITION	pos = GetFirstSelectedItemPosition();

					while (pos != NULL)
					{
						CServer	* pServer = GetServerAt(GetNextSelectedItem(pos));

						pServer->SetPreference(CServer::SERVERPRIORITY_NORMAL);
						if (pServer->IsStaticMember())
							StaticServerFileAppend(pServer);
						g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshServer(*pServer);
					}
					break;
				}
			//#endregion
			//#region Set Server Priority to "High"
				case MP_PRIOHIGH:
				{
					POSITION	pos = GetFirstSelectedItemPosition();

					while (pos != NULL)
					{
						CServer	* pServer = GetServerAt(GetNextSelectedItem(pos));

						pServer->SetPreference(CServer::SERVERPRIORITY_HIGH);
						if (pServer->IsStaticMember())
							StaticServerFileAppend(pServer);
						g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshServer(*pServer);
					}
					break;
				}
			//#endregion
			//#region Get ED2K Link for Server
				case MP_GETED2KLINK:
				{
					POSITION	pos = GetFirstSelectedItemPosition();
					CString	strBuffer, strLink;

					while (pos != NULL)
					{
						CServer	* pServer = GetServerAt(GetNextSelectedItem(pos));

						strBuffer.Format(_T("ed2k://|server|%s|%d|/"), pServer->GetFullIP(), pServer->GetPort());
						if (strLink.GetLength() > 0)
							strBuffer = _T("\n") + strBuffer;
						strLink += strBuffer;
					}
					g_eMuleApp.CopyTextToClipboard(strLink);
					break;
				}
			//#endregion
			//#region IRC Set Send Link
				case Irc_SetSendLink:
				{
					POSITION	pos = GetFirstSelectedItemPosition();
					CString	strBuffer, strLink;

					while (pos != NULL)
					{
						CServer	* pServer = GetServerAt(GetNextSelectedItem(pos));

						strBuffer.Format(_T("ed2k://|server|%s|%d|/"), pServer->GetFullIP(), pServer->GetPort());
						if (strLink.GetLength() > 0)
							strBuffer = _T("\n") + strBuffer;
						strLink += strBuffer;
					}
					g_eMuleApp.m_pdlgEmule->m_wndIRC.SetSendFileString(strLink);
					break;
				}
			//#endregion
			}
		}
	}
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	OnNMLdblclk() is the left-double-click message handler
void CServerListCtrl::OnNMLdblclk(NMHDR *pNMHDR, LRESULT *pResult)
{
	if (GetSelectionMark() != ( -1))
	{
#ifdef OLD_SOCKETS_ENABLED
		if (g_eMuleApp.m_pServerConnect->IsConnected())
		{
			if ( !_tcscmp( GetSelectedServer()->GetAddress(),
			               (g_eMuleApp.m_pServerConnect->GetCurrentServer())->GetAddress() ) )
			{
				AddLogLine(false, IDS_ALREADYCONNECTED, GetSelectedServer()->GetListName());
				return;
			}
		}
		g_eMuleApp.m_pServerConnect->ConnectToServer(*GetSelectedServer());
#endif //OLD_SOCKETS_ENABLED
#ifdef NEW_SOCKETS

		CServer	*pServer = GetSelectedServer();

		if (pServer != NULL)
			g_eMuleApp.m_pEngine->ConnectToServer(pServer);
#else
		g_eMuleApp.m_pdlgEmule->ShowConnectionState(false);
#endif //NEW_SOCKETS
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CServerListCtrl::AddServerMetToList(CString strFile)
{
	SetRedraw(false);

	bool	bSucceeded = m_pServerList->AddServerMetToList(strFile);

	RemoveDeadServer();
	ShowFilesCount();
	SetRedraw(true);
	return bSucceeded;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	OnLvnColumnclickServlist() is the column header click message handler
void CServerListCtrl::OnLvnColumnclickServlist(NMHDR *pNMHDR, LRESULT *pResult)
{
	NM_LISTVIEW	* pNMListView = reinterpret_cast<NM_LISTVIEW*>(pNMHDR);

	int	iFlags = 0;
//
//	For the two double columns, toggle the Alt column flag when the arrow is facing up
	if (pNMListView->iSubItem == 4)
	{
		if (m_bSortAscending[4])
			m_bSortAscending[11] = !m_bSortAscending[11];
		iFlags = m_bSortAscending[11] ? 0 : MLC_SORTALT;
	}
	if (pNMListView->iSubItem == 9)
	{
		if (m_bSortAscending[9])
			m_bSortAscending[12] = !m_bSortAscending[12];
		iFlags = m_bSortAscending[12] ? 0 : MLC_SORTALT;
	}
//	if it's a second click on the same column then reverse the sort order,
//	otherwise sort the new column in ascending order.
	m_bSortAscending[pNMListView->iSubItem] = !m_bSortAscending[pNMListView->iSubItem];
	if (iFlags == 0)
		SetSortArrow(pNMListView->iSubItem, m_bSortAscending[pNMListView->iSubItem]);
	else
		SetSortArrow(pNMListView->iSubItem, m_bSortAscending[pNMListView->iSubItem] ? arrowDoubleUp : arrowDoubleDown);
	SortItems(&SortProc, pNMListView->iSubItem + iFlags + ((m_bSortAscending[pNMListView->iSubItem]) ? MLC_SORTASC : MLC_SORTDESC)); // double arrows
	Invalidate();
	*pResult = 0;
	g_eMuleApp.m_pGlobPrefs->SetColumnSortItem(CPreferences::TABLE_SERVER, pNMListView->iSubItem);
	g_eMuleApp.m_pGlobPrefs->SetColumnSortAscending(CPreferences::TABLE_SERVER, m_bSortAscending[pNMListView->iSubItem]);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CServerListCtrl::SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	CServer	* pServer1 = reinterpret_cast<CServer*>(lParam1);
	CServer	*pServer2 = reinterpret_cast<CServer*>(lParam2);

	if (pServer1 == NULL || pServer2 == NULL)
		return 0;

	int		iTemp = 0;
	int		iCounter1;
	int		iCounter2;
	int		iCompare = 0;
	bool	bSortAscending = (lParamSort & MLC_SORTDESC) == 0;
	int		iSortColumn = (lParamSort & MLC_COLUMNMASK);
	int		iSortAltFlag = (lParamSort & MLC_SORTALT);
	int		iSortMod = bSortAscending ? 1 : -1;

	switch (iSortColumn + iSortAltFlag)
	{
		//#region Server Name
		case SL_COLUMN_SERVERNAME:
		{
			bool	bServerHasNoName1 = _tcsstr(pServer1->GetListName(), pServer1->GetFullIP());
			bool	bServerHasNoName2 = _tcsstr(pServer2->GetListName(), pServer2->GetFullIP());

			if (!bServerHasNoName1 && !bServerHasNoName2)
				iCompare = _tcsicmp(pServer1->GetListName(), pServer2->GetListName());
			else
				iCompare = bServerHasNoName1 ? (bServerHasNoName2 ? 0 : 1) : -1;

			if (iCompare == 0)
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERIP);
			break;
		}
		//#endregion
		//#region Server IP
		case SL_COLUMN_SERVERIP:
		{
		//	If both are dynamic IP...
			if (pServer1->HasDynIP() && pServer2->HasDynIP())
			{
				//iCompare = CString(pServer1->GetDynIP()).CompareNoCase(pServer2->GetDynIP());
				iCompare = _tcsicmp(pServer1->GetDynIP(), pServer2->GetDynIP());
			}
		//	If only the first is dynamic IP...
			else if (pServer1->HasDynIP())
			{
				iCompare = -1;
			}
		//	If only the second is dynamic IP...
			else if (pServer2->HasDynIP())
			{
				iCompare = 1;
			}
		//	If both have static IPs...
			else
			{
				CString		sIP1, sIP2, sTemp1, sTemp2;

				iCounter1 = iCounter2 = iTemp = 0;
				sIP1 = pServer2->GetFullIP();
				sIP2 = pServer1->GetFullIP();
				for (int i = 0; iTemp == 0 ; i++)
				{
					sTemp1 = sIP1.Tokenize(_T("."), iCounter1);
					sTemp2 = sIP2.Tokenize(_T("."), iCounter2);
					iTemp = _tstoi(sTemp2) - _tstoi(sTemp1);
				//	If the IPs are the same...
					if (i > 2)
					{
						iCompare = pServer1->GetPort() - pServer2->GetPort();
						break;
					}
					else if (iTemp != 0)
					{
						iCompare = iTemp;
					}
				}
			}
			break;
		}
		//#endregion
		//#region Description
		case SL_COLUMN_DESCRIPTION:
		{
			CString strServerDescription1 = pServer1->GetDescription();
			CString strServerDescription2 = pServer2->GetDescription();

			if (!strServerDescription1.IsEmpty() && !strServerDescription2.IsEmpty())
				iCompare = _tcsicmp(strServerDescription1, strServerDescription2);
			else
			{
				iCompare = strServerDescription1.IsEmpty() ? (strServerDescription2.IsEmpty() ? 0 : 1) : -1;
				iSortMod = 1;		//empty entries at the bottom in any case
			}

			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERNAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		//#endregion
		//#region Ping
		case SL_COLUMN_PING:
		{
			iCompare = pServer1->GetPing() - pServer2->GetPing();
			if (!pServer1->GetPing() || !pServer2->GetPing())
				iSortMod = -1;
			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERNAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		//#endregion
		//#region Num Users / Max Users
		case SL_COLUMN_NUMUSERS:
		{
			iCompare = pServer1->GetNumUsers() - pServer2->GetNumUsers();
			if (!pServer1->GetNumUsers() || !pServer2->GetNumUsers())
				iSortMod = -1;
			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERNAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		case SL_COLUMN_NUMUSERS + MLC_SORTALT:    //max. users
		{
			iCompare = pServer1->GetMaxUsers() - pServer2->GetMaxUsers();
			if (!pServer1->GetMaxUsers() || !pServer2->GetMaxUsers())
				iSortMod = -1;
			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERNAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		//#endregion
		//#region Number of Files
		case SL_COLUMN_NUMFILES:
		{
			iCompare = pServer1->GetFiles() - pServer2->GetFiles();
			if (!pServer1->GetFiles() || !pServer2->GetFiles())
				iSortMod = -1;
			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERNAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		//#endregion
		//#region Preferences
		case SL_COLUMN_PREFERENCES:
		{
			iCompare = pServer1->GetPreferences() - pServer2->GetPreferences();
			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERNAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		//#endregion
		//#region Failed Count
		case SL_COLUMN_FAILEDCOUNT:
		{
			iCompare = pServer1->GetFailedCount() - pServer2->GetFailedCount();
			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERNAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		//#endregion
		//#region Static
		case SL_COLUMN_STATIC:
		{
			//	If both are static...
			int iStatic1 = pServer1->IsStaticMember() ? 1:0;
			int iStatic2 = pServer2->IsStaticMember() ? 1:0;

			iCompare = iStatic1 - iStatic2;
			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERNAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		//#endregion
		//#region Soft File Limit / Hard File Limit
		case SL_COLUMN_SOFTFILELIMIT:
		{
			iCompare = pServer1->GetSoftMaxFiles() - pServer2->GetSoftMaxFiles();
			if (!pServer1->GetSoftMaxFiles() || !pServer2->GetSoftMaxFiles())
				iSortMod = -1;
			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERNAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		case SL_COLUMN_SOFTFILELIMIT + MLC_SORTALT:    //Hard files asc
		{
			iCompare = pServer1->GetHardMaxFiles() - pServer2->GetHardMaxFiles();
			if (!pServer1->GetHardMaxFiles() || !pServer2->GetHardMaxFiles())
				iSortMod = -1;
			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERNAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		//#endregion
		//#region Software Version
		case SL_COLUMN_SOFTWAREVER:
		{
			CString strServerVersion1 = pServer1->GetVersion();
			CString strServerVersion2 = pServer2->GetVersion();

			if (!strServerVersion1.IsEmpty() && !strServerVersion2.IsEmpty())
				iCompare = _tcsicmp(strServerVersion1, strServerVersion2);
			else
			{
				iCompare = strServerVersion1.IsEmpty() ? (strServerVersion2.IsEmpty() ? 0 : 1) : -1;
				iSortMod = 1;		//empty entries at the bottom in any case
			}

			if (iCompare == 0)
			{
				iCompare = SortProc(lParam1,lParam2,SL_COLUMN_SERVERNAME);
				iSortMod = 1;		//eklmn: sort allways in ascending order
			}
			break;
		}
		//#endregion
		default:
		{
			iCompare = 0;
		}
	}

	return iCompare * iSortMod;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CServerListCtrl::StaticServerFileAppend(CServer *pServer)
{
	try
	{
	//	Remove any entry before writing to avoid duplicates
		StaticServerFileRemove(pServer);

		FILE	*pStaticServersFile = _tfopen(g_eMuleApp.m_pGlobPrefs->GetConfigDir() + CString(_T("staticservers.dat")), _T("a"));

		if (pStaticServersFile == NULL)
		{
			AddLogLine(false, IDS_ERROR_SSF);
			return false;
		}

		if ( fprintf( pStaticServersFile,
		              "%s:%i,%i,%s\n",
		              pServer->GetAddress(),
		              pServer->GetPort(),
		              pServer->GetPreferences(),
		              pServer->GetListName() ) != EOF )
		{
			if (!pServer->IsStaticMember())
				AddLogLine(false, _T("'%s:%i,%s' %s"), pServer->GetAddress(), pServer->GetPort(), pServer->GetListName(), GetResString(IDS_ADDED2SSF));
			pServer->SetIsStaticMember(true);
			g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshServer(*pServer);
		}

		fclose(pStaticServersFile);
	}
	catch (...)
	{
		return false;
	}
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool CServerListCtrl::StaticServerFileRemove(CServer *pServer)
{
	try
	{
		if (!pServer->IsStaticMember())
			return true;

		CString		strLine;
		CString		strTest;
		char		arrcBuffer[1024];
		int			iBufLen = 1024;
		int			iPos;
		CString		strStaticFilePath = g_eMuleApp.m_pGlobPrefs->GetConfigDir() + CString("staticservers.dat");
		CString		strStaticTempPath = g_eMuleApp.m_pGlobPrefs->GetConfigDir() + CString("statictemp.dat");
		FILE	   *pStaticServersFile = _tfopen(strStaticFilePath , _T("r"));
		FILE	   *pStaticTempFile = _tfopen(strStaticTempPath , _T("w"));

		if ((pStaticServersFile == NULL) || (pStaticTempFile == NULL))
		{
			AddLogLine(false, IDS_ERROR_SSF);
			return false;
		}

		while (!feof(pStaticServersFile))
		{
			if (fgets(arrcBuffer, iBufLen, pStaticServersFile) == 0)
				break;

			strLine = arrcBuffer;

		//	Ignore comments or invalid lines
			if (strLine.GetAt(0) == '#' || strLine.GetAt(0) == '/')
			{
				fprintf(pStaticTempFile, arrcBuffer);
				continue;
			}
			if (strLine.GetLength() < 5)
			{
				fprintf(pStaticTempFile, arrcBuffer);
				continue;
			}

		//	Only interested in "host:port"
			iPos = strLine.Find(',');
			if (iPos == -1)
				continue;
			strLine = strLine.Left(iPos);

		//	Get host and port from given pServer
			strTest.Format(_T("%s:%i"), pServer->GetAddress(), pServer->GetPort());

		//	Compare, if not the same pServer write original line to temp file
			if (strLine.Compare(strTest) != 0)
				fprintf(pStaticTempFile, arrcBuffer);
		}

		fclose(pStaticServersFile);
		fclose(pStaticTempFile);

	//	All ok, remove the existing file and replace with the new one
		CFile::Remove(strStaticFilePath);
		CFile::Rename(strStaticTempPath, strStaticFilePath);

		AddLogLine(false, _T("'%s:%i,%s' %s"), pServer->GetAddress(), pServer->GetPort(), pServer->GetListName(), GetResString(IDS_REMOVEDFROMSSF));
		pServer->SetIsStaticMember(false);
		g_eMuleApp.m_pdlgEmule->m_wndServer.m_ctlServerList.RefreshServer(*pServer);
	}
	catch (...)
	{
		return false;
	}
	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CServerListCtrl::ShowFilesCount()
{
	CString		strCount;

	strCount.Format(_T(" (%i)"), GetItemCount());
	g_eMuleApp.m_pdlgEmule->m_wndServer.GetDlgItem(IDC_SERVLIST_TEXT)->SetWindowText(GetResString(IDS_SV_SERVERLIST) + strCount);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
