//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// TransferWnd.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "TransferWnd.h"
#include "otherfunctions.h"
#include "AddBuddy.h"
#include "CatDialog.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define TRANS_ROLLUP		120
#define TRANS_DOWNLOADLIST	121
#define TRANS_UPLOADLIST	122
#define TRANS_QUEUELIST		123
#define TRANS_INFOLIST		124
#define TRANS_DOWNLOADTABS	125
#define TRANS_TABWINDOW		126
#define TRANS_CLIENTLIST	127
#define TRANS_DUMMY			130


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class CDummyForTabs : public CWnd
{
public:
	CDummyForTabs(){ m_pChild = NULL; }

	void SetChild(CWnd* pChild){ m_pChild = pChild;	}

	CWnd* GetChild(){ return m_pChild; }

	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
	{
		EMULE_TRY
		NMHDR* pNMHDR = (NMHDR*)lParam;
		switch(pNMHDR->code)
		{
		case LVN_ITEMACTIVATE:
		case LVN_COLUMNCLICK:
		case NM_CLICK:
		case NM_DBLCLK:
			break;
		default:
			*pResult = GetParent()->GetParent()->SendMessage(WM_NOTIFY, wParam, lParam);
			return TRUE;
		}
		EMULE_CATCH2
		return CWnd::OnNotify(wParam, lParam, pResult);
	}


	afx_msg void OnSize(uInt nType, int cx, int cy)
	{
		EMULE_TRY
		if(m_pChild)
		{
			CRect r;
			GetClientRect(&r);
			r -= CSize(2,2);
			m_pChild->SetWindowPos(NULL, 0,0, r.Width(), r.Height(), SWP_NOMOVE|SWP_NOZORDER);
		}
		EMULE_CATCH2
	}

	DECLARE_DYNCREATE(CDummyForTabs)
	DECLARE_MESSAGE_MAP()

private:
	CWnd* m_pChild;
};
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CCatTabs::DrawItem(CDC *pDC, int iItem)
{
#define COLORBARHEIGHT	2
//#define TRIANGLESIZE	15
#define TRIANGLESIZE	((rItem.bottom-rItem.top+1)/2)
	CTabs::DrawItem(pDC,iItem);

//	Draw the category color bar for user categories.
	if (iItem >= CCat::GetNumPredefinedCats() && iItem < CCat::GetNumCats())
	{
		CRect		rItem;
		CRect		rClient;
		COLORREF	cr;

		GetClientRect(rClient);
		GetItemRect(iItem, rItem);
#ifdef USE_BAR
#ifndef NEW_LOOK
		rItem.top = rClient.top;
		rItem.bottom = rItem.top + COLORBARHEIGHT;
		cr = CCat::GetCatColorByIndex(iItem);
		pDC->FillSolidRect(&rItem,cr);
#else
		if (iItem == GetCurSel())
		{
			rItem.top = rClient.top;
		}
		rItem.top++;
		rItem.bottom = rItem.top + COLORBARHEIGHT;
		cr = CCat::GetCatColorByIndex(iItem);

		CPen		*pOldPen,barPen;

		barPen.CreatePen(PS_SOLID,0,cr);
		pOldPen = pDC->SelectObject(&barPen);
		pDC->MoveTo(rItem.left+1,rItem.top);
		pDC->LineTo(rItem.right-1,rItem.top);
		pDC->MoveTo(rItem.left,rItem.top+1);
		pDC->LineTo(rItem.right,rItem.top+1);
		pDC->SelectObject(pOldPen);
//		pDC->FillSolidRect(&rItem,cr);
#endif NEW_LOOK

#else
		CBrush		*pOldBrush,newBrush;

		cr = CCat::GetCatColorByIndex(iItem);
		newBrush.CreateSolidBrush(cr);
		pOldBrush = pDC->SelectObject(&newBrush);
		rItem.top = rClient.top;
		pDC->BeginPath();
		pDC->MoveTo(rItem.left+2,rItem.top+1);
		pDC->LineTo(rItem.left+2+TRIANGLESIZE,rItem.top+1);
		pDC->LineTo(rItem.left+2,rItem.top+1+TRIANGLESIZE);
		pDC->EndPath();
		pDC->FillPath();
		pDC->SelectObject(pOldBrush);
#endif USE_BAR
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNAMIC(CDummyForTabs, CWnd)

BEGIN_MESSAGE_MAP(CDummyForTabs, CWnd)
	ON_WM_SIZE()
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CTransferWnd, CResizableDialog)
	//BEGIN Improved Tooltips
	//ON_NOTIFY_EX_RANGE(TTN_NEEDTEXT,0,0xFFFF,OnToolTipNotify)
	ON_NOTIFY_EX_RANGE(UDM_TOOLTIP_DISPLAY,0,0xFFFF,OnToolTipNotify)
	//END Improved Tooltips
	ON_WM_DESTROY()	// eklmn: bugfix(00): resource cleanup due to CResizableDialog
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	
//	ON_NOTIFY(TCN_SELCHANGE, TRANS_DOWNLOADTABS, OnTcnSelchangeDltab)
//	ON_NOTIFY(NM_RCLICK, TRANS_DOWNLOADTABS, OnNMRClickDltab)
//	ON_NOTIFY(NM_TABMOVED, TRANS_DOWNLOADTABS, OnTabMovement)
// ON_NOTIFY(LVN_BEGINDRAG, TRANS_DOWNLOADLIST, OnLvnBeginDrag)

	ON_WM_LBUTTONDBLCLK()
END_MESSAGE_MAP()

// CTransferWnd dialog

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNAMIC(CTransferWnd, CDialog)
CTransferWnd::CTransferWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CTransferWnd::IDD, pParent)
{	
	m_bIsDragging = false;
	m_pwndDummyForDownloadList = NULL;
	m_pttDlTabToolTips = NULL;

	m_pLastMousePoint.x = 0;
	m_pLastMousePoint.y = 0;

	m_nLastCatTT = -1;	//none 
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CTransferWnd::~CTransferWnd()
{	
	if (m_pttDlTabToolTips != NULL)
		m_pttDlTabToolTips->DestroyToolTipCtrl();
	SaveRollupItemHeights();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CTransferWnd::OnInitDialog()
{	
	EMULE_TRY

	CResizableDialog::OnInitDialog();
	m_bFirstShow=true;
	//Localize();

	//
	//	Create the Rollup control
	//
	CRect rRollupArea;

	GetClientRect(&rRollupArea);
	rRollupArea.DeflateRect(11,11);
	
	m_ctlRollup.Create(NULL, NULL, WS_CHILD|WS_VISIBLE/*|WS_CLIPCHILDREN*/, rRollupArea, this, TRANS_ROLLUP);

	//
	//	Create the Download-list control
	//
	CWnd *pParent = &m_ctlRollup;
	CRect rItem = CRect(0,0,0,0);
	
	DWORD dwListStyle = WS_CHILD|WS_BORDER|WS_TABSTOP|LVS_REPORT|LVS_ALIGNLEFT|
						LVS_OWNERDRAWFIXED|LVS_SINGLESEL;
	DWORD dwTabStyle = WS_CHILD|WS_VISIBLE|TCS_HOTTRACK|TCS_SINGLELINE|TCS_TOOLTIPS;

	m_pwndDummyForDownloadList = new CDummyForTabs();
	m_pwndDummyForDownloadList->Create(AfxRegisterWndClass(0), "", WS_CHILD|WS_VISIBLE, rItem, pParent, TRANS_DUMMY);

	m_ctlDownloadList.Create(WS_VISIBLE | dwListStyle, rItem, m_pwndDummyForDownloadList, TRANS_DOWNLOADLIST);

	g_eMuleApp.m_pDownloadList->SetDownloadListCtrl(&m_ctlDownloadList);
	m_ctlUploadList.Create(WS_VISIBLE | dwListStyle, rItem, pParent, TRANS_UPLOADLIST);
	m_ctlQueueList.Create(/*WS_VISIBLE |*/ dwListStyle, rItem, pParent, TRANS_QUEUELIST);
	m_ctlClientList.Create(/*WS_VISIBLE |*/ dwListStyle, rItem, pParent, TRANS_CLIENTLIST);

	g_eMuleApp.m_pClientList->SetClientListCtrl(&m_ctlClientList);

	m_ctlInfoList.Create(WS_VISIBLE|WS_CHILD|WS_BORDER|WS_TABSTOP|LVS_REPORT|
							LVS_ALIGNLEFT|LVS_SINGLESEL, rItem, pParent, TRANS_INFOLIST);
	m_ctlDLTabs.Create(dwTabStyle, CRect(0,0,0,20), pParent, TRANS_DOWNLOADTABS);	

	m_ctlDLTabs.ModifyStyle(WS_CLIPSIBLINGS, 0);

	m_pwndDummyForDownloadList->SetChild(&m_ctlDownloadList);

	AddBuddy(m_pwndDummyForDownloadList->m_hWnd, m_ctlDLTabs.m_hWnd, BDS_TOP);

	CString strDownloads;
	strDownloads.Format(GetResString(IDS_RUP_DOWNINFO), g_eMuleApp.m_pDownloadQueue->GetFileCount(),
						g_eMuleApp.m_pDownloadQueue->GetTransferringFiles(),
						static_cast<double>(g_eMuleApp.m_pDownloadQueue->GetDataRate()) / 1024.0);
	CString strUploads;	
	strUploads.Format(GetResString(IDS_RUP_UPINFO), g_eMuleApp.m_pUploadQueue->GetWaitingUserCount(),
					  g_eMuleApp.m_pUploadQueue->GetUploadQueueLength(), 
					  g_eMuleApp.m_pUploadQueue->GetBanCount(),
					  static_cast<double>(g_eMuleApp.m_pUploadQueue->GetDataRate())/1024.0);
	
	m_ctlRollup.InsertItem(GetResString(IDS_RUP_DOWNLOADS), strDownloads, m_pwndDummyForDownloadList, 0, TRUE);
	m_ctlRollup.InsertItem(GetResString(IDS_RUP_UPLOADS), strUploads, &m_ctlUploadList, 1, TRUE);
	m_ctlRollup.InsertItem(GetResString(IDS_RUP_INFO), _T(""), &m_ctlInfoList, 2, FALSE);

	AddAnchor(m_ctlRollup.m_hWnd, TOP_LEFT, BOTTOM_RIGHT);
	
	InitRollupItemHeights();

	m_ctlDownloadList.Init();
	m_ctlUploadList.Init();
	m_ctlQueueList.Init();
	m_ctlClientList.Init();

	m_ctlDownloadList.SetOwner(this);
	m_ctlUploadList.SetOwner(this);
	m_ctlQueueList.SetOwner(this);
	m_ctlClientList.SetOwner(this);
	m_ctlDLTabs.SetOwner(this);
		
	m_nActiveWnd = MPW_UPLOADLIST;
	m_iTabRightClickIndex = -1;
	
	// create tooltip
	m_ttip.Create(this);
	m_ttip.SetDelayTime(TTDT_AUTOPOP, 20000);
	m_ttip.SetDelayTime(TTDT_INITIAL, g_eMuleApp.m_pGlobPrefs->GetToolTipDelay()*1000+25);	//netwolf: avoid jitter when delay is set to 0
	m_ttip.SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX); // recognize \n chars!

	//BEGIN Improved Tooltips
	m_ttip.SetBehaviour(PPTOOLTIP_MULTIPLE_SHOW);
	m_ttip.SetNotify(m_hWnd);
	m_ttip.AddTool(&m_ctlDownloadList, _T(""));
	m_ttip.AddTool(&m_ctlUploadList, _T(""));
//	m_ttip.SetFont(_T("Courier"), 9);
	//END Improved Tooltips

	//
	//	Initialize the Category tabs
	//
	for (int ix = 0; ix < CCat::GetNumCats(); ix++)
		m_ctlDLTabs.InsertItem(ix,CCat::GetCatByIndex(ix)->GetTitle() );
	m_pttDlTabToolTips= new CToolTipCtrl;
	m_pttDlTabToolTips->Create(this, TTS_NOPREFIX);
	m_ctlDLTabs.SetToolTips(m_pttDlTabToolTips);
	UpdateTabToolTips();
	m_pttDlTabToolTips->SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX); // recognize \n chars!
	m_pttDlTabToolTips->SetDelayTime(TTDT_AUTOPOP, 20000);
	m_pttDlTabToolTips->SetDelayTime(TTDT_INITIAL, 0);
	m_pttDlTabToolTips->Activate(TRUE);

	m_iOldToolTipItemDown = -1;
	m_iOldToolTipItemUp = -1;
	m_iOldToolTipItemQueue = -1;
		
	EMULE_CATCH

	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// v- eklmn: bugfix(00): resource cleanup due to CResizableDialog
void CTransferWnd::OnDestroy()
{	
	if(m_pwndDummyForDownloadList)
	{
		m_pwndDummyForDownloadList->DestroyWindow();
		delete m_pwndDummyForDownloadList;
	}
	CResizableDialog::OnDestroy();
}

// ^- eklmn: bugfix(00): resource cleanup due to CResizableDialog
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::DoDataExchange(CDataExchange* pDX)
{	
	CResizableDialog::DoDataExchange(pDX);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CTransferWnd message handlers
BOOL CTransferWnd::PreTranslateMessage(MSG* pMsg)
{
	// eklmn: bugfix(07): Update tooltip only in case corresponding WM_MESSAGE
	if (pMsg->message == WM_LBUTTONDOWN || pMsg->message == WM_LBUTTONUP 
		|| pMsg->message == WM_RBUTTONDOWN || pMsg->message == WM_RBUTTONUP 
		|| pMsg->message == WM_MOUSEMOVE || pMsg->message == WM_MOUSEWHEEL
		|| pMsg->message == WM_KEYDOWN || pMsg->message == WM_SYSKEYDOWN )
	{
		m_ttip.RelayEvent(pMsg);
	}

	if (pMsg->message == WM_MOUSEMOVE || pMsg->message == WM_MOUSEWHEEL)
	{
		POINT point;
		::GetCursorPos(&point);
		if (point.x!=m_pLastMousePoint.x || point.y!=m_pLastMousePoint.y)
		{
			m_pLastMousePoint=point;

		//	Handle tooltip updating, when mouse is moved from one item to another
			if (pMsg->message == WM_MOUSEMOVE || pMsg->message == WM_MOUSEWHEEL)
			UpdateToolTips();

			CPoint pt(point);
			m_nTabDropIndex=GetTabUnderMouse(&pt);

			if (m_nTabDropIndex!=m_nLastCatTT)
			{
				m_nLastCatTT=m_nTabDropIndex;
				if (m_nTabDropIndex!=-1)
					UpdateTabToolTips(m_nTabDropIndex);
			}
		}
	}

	if(pMsg->message == USRMSG_SWITCHUPLOADLIST)
		SwitchUploadList();

	if (m_ctlDownloadList.GetSelectionMark() != -1) 
	{
		EnumExpandType expandtype = EXPAND_COLLAPSE;

		if (GetAsyncKeyState(VK_ADD) < 0)
		{
			expandtype = EXPAND_ONLY;
		}
		else if (GetAsyncKeyState(VK_SUBTRACT) < 0) 
		{		
			expandtype = COLLAPSE_ONLY;
		}
		if (expandtype < EXPAND_COLLAPSE) 
		{
			m_ctlDownloadList.ExpandCollapseItem(m_ctlDownloadList.GetSelectionMark(), expandtype, true);
		}
	}

	return CResizableDialog::PreTranslateMessage(pMsg);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::UpdateToolTips(void)
{	
	EMULE_TRY

	//
	//	Update tooltips for DownloadList
	CListCtrl *pListCtrl = &m_ctlDownloadList;//(CListCtrl*)m_ctlRollup.GetItemClient(0);
	int sel = GetItemUnderMouse(pListCtrl);	// this is a quick fix,

	if (sel != -1)							// we should find a better solution
	{
		if (sel != m_iOldToolTipItemDown)
		{
			if(m_ttip.IsWindowVisible())
			{	
				//BEGIN Improved Tooltips
				//m_ttip.Update();
				m_ttip.UpdateData();
				//END Improved Tooltips
			}
			m_iOldToolTipItemDown = sel;
			return;
		}
	}

	//
	//	Update tooltips for UploadList
	int sel2 = GetItemUnderMouse((CListCtrl*)m_ctlRollup.GetItemClient(1));	// see above

	if (sel2 != -1)
	{
		if (sel2 != m_iOldToolTipItemUp)
		{
			if(m_ttip.IsWindowVisible())
			{	
				// Improved Tooltips
				m_ttip.UpdateData();
			}
			m_iOldToolTipItemUp = sel2;
			return;
		}
	}

	//
	//	Update tooltips for InfoList
/* no tooltips needed ATM
*/
	if (sel == -1 && sel2 == -1 /*&& sel3 != -1*/)
		m_ttip.Pop();

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CTransferWnd::GetItemUnderMouse(CListCtrl* ctrl)
{	
	EMULE_TRY

	CPoint pt;

	::GetCursorPos(&pt);
	ctrl->ScreenToClient(&pt);

	LVHITTESTINFO hit, subhit;

	hit.pt = pt;
	subhit.pt = pt;
	ctrl->SubItemHitTest(&subhit);

	int sel = ctrl->HitTest(&hit);

	if (sel != LB_ERR && (hit.flags & LVHT_ONITEM))
	{
		if (subhit.iSubItem == 0)
			return sel;
	}

	EMULE_CATCH

	return LB_ERR;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CTransferWnd::OnToolTipNotify(UINT id, NMHDR *pNMH, LRESULT *pResult)
{	
	EMULE_TRY

	//BEGIN Improved Tooltips
	//TOOLTIPTEXT *pText = (TOOLTIPTEXT *)pNMH;
	//int control_id = ::GetDlgCtrlID((HWND)pNMH->idFrom);
	NM_PPTOOLTIP_DISPLAY * pNotify = (NM_PPTOOLTIP_DISPLAY*)pNMH;
	int control_id = CWnd::FromHandle(pNotify->ti->hWnd)->GetDlgCtrlID();
	//END Improved Tooltips

	if (!control_id)
		return FALSE;

	CString info;
	if (control_id == TRANS_DOWNLOADLIST)
	{
		if (m_ctlDownloadList.GetItemCount() < 1)
			return FALSE;

		int sel = GetItemUnderMouse(&m_ctlDownloadList);
		if (sel < 0 || sel == 65535)
			return FALSE;

	//	Build info text and display it
		CMuleCtrlItem		*pItem = reinterpret_cast<CMuleCtrlItem*>(m_ctlDownloadList.GetItemData(sel));
		CPartFileDLItem		*pPartFileItem = dynamic_cast<CPartFileDLItem*>(pItem);
		CSourceDLItem		*pSourceItem = dynamic_cast<CSourceDLItem*>(pItem);

		if (pPartFileItem != NULL)
		{
			CPartFile		*pPartFile = pPartFileItem->GetFile();

		//	BEGIN Improved Tooltips
			info = pPartFile->GetDownloadFileInfo4Tooltips();

			SHFILEINFO		shfi;

			memset2(&shfi,0,sizeof(shfi));
			SHGetFileInfo( pPartFile->GetFileName(),
						   FILE_ATTRIBUTE_NORMAL, &shfi, sizeof(shfi),
						   SHGFI_ICON|SHGFI_USEFILEATTRIBUTES );
			pNotify->ti->hIcon = shfi.hIcon;

			m_ctlDownloadList.SetFocus();
		//	END Improved Tooltips
		}
		else if (pSourceItem != NULL)
		{
#ifdef OLD_SOCKETS_ENABLED
			bool				bA4AF = pSourceItem->IsAskedForAnotherFile();
			CUpDownClient	   *pSource = pSourceItem->GetSource();
			in_addr				serverAddr;

			serverAddr.S_un.S_addr = pSource->GetServerIP();

		//	BEGIN Improved Tooltips
			info.Format( GetResString(IDS_TT_USERINFO)
					   + GetResString(IDS_TT_CLIENT)
					   + GetResString(IDS_TT_SERVER)
					   + GetResString(IDS_TT_SOURCEINFO)
					   + GetResString(IDS_TT_SOURCEINFO2),
					   pSource->GetUserName(), pSource->GetUserID(),
					   pSource->GetFullIP(), pSource->GetUserPort(),
					   inet_ntoa(serverAddr), pSource->GetServerPort(),
					   pSource->GetAskedCountDown(), pSource->GetAvailablePartCount());

			if (!bA4AF)
			{
			//	Normal client
				CString		strClientSrcName;

				strClientSrcName.Format( GetResString(IDS_TT_CLIENTSOURCENAME),
										 CString(pSource->GetClientFilename()) );
				info += strClientSrcName;
			}
		//	If Asked For Another File...
			else
			{
			//	Cax2- get local file name
				try
				{
					CString		strA4AFFileName;

					strA4AFFileName.Format( GetResString(IDS_TT_ASKEDFAF),
											pSource->m_pReqPartFile->GetFileName() );
					info += strA4AFFileName;
				}
				catch(...)
				{
				}
            }
         //-For File Comment-// 
			try 
			{ 
				if (!bA4AF)
				{
					if (pSource->GetFileComment() != "")
					{ 
						CString		strFileComment;

						strFileComment.Format( GetResString(IDS_TT_CMT_READ),
											   CString(pSource->GetFileComment()) );
						info += strFileComment; 
					} 
					else 
					{ 
					//	No comment entered 
						info += GetResString(IDS_TT_CMT_NONE); 
					} 
				//
				//	File rating
					if (GetRatingString(pSource->GetFileRating()) == GetResString(IDS_CMT_NOTRATED))
					{
						info += GetResString(IDS_TT_CMT_NOTRATED);
					}
					else
					{
						CString		strRating;

						strRating.Format( GetResString(IDS_TT_CMT_RATING),
										  GetRatingString(pSource->GetFileRating()) );
						info += strRating;
					} 
				}
			} 
			catch(...) 
			{ 
				//Information not received = not connected or connecting 
				info += GetResString(IDS_TT_CMT_NOTCONNECTED); 
			} 
	         //-End file comment-//

			//Set the tooltip icon - Hehe with new icons this time :P
			switch(pSource->GetClientSoft()) 
			{
				case SO_CDONKEY:
					pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_CDONKEY);
					break;
				case SO_LMULE:
					pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_LMULE);
					break;
				case SO_SHAREAZA:
					pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_SHAREAZA);
					break;
				case SO_EDONKEYHYBRID:
					pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_EDONKEYHYBRID);
					break;
				case SO_MLDONKEY:
					pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_MLDONKEY);
					break;
				case SO_EMULE:
				case SO_OLDEMULE:
					if(pSource->m_pCredits->GetCurrentIdentState(pSource->GetIP()) != IS_IDENTIFIED)
						pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_SECUREHASH);
					else
						pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_COMPROT);
					break;
				case SO_EDONKEY:
					pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_NORMAL);
					break;
				default:
					pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_UNKNOWN);
					break;
			}
			//END Improved Tooltips
#endif //OLD_SOCKETS_ENABLED
		}
	}
	else if (control_id == TRANS_UPLOADLIST)
	{
		if (m_ctlUploadList.GetItemCount() < 1)
			return FALSE;

		int sel = GetItemUnderMouse(&m_ctlUploadList);
		if (sel < 0 || sel == 65535)
			return FALSE;

		CUpDownClient* pSource = (CUpDownClient*)m_ctlUploadList.GetItemData(sel);

		info = pSource->GetUploadFileInfo4Tooltips();

		//Set the tooltip icon - Hehe with new icons this time :P
		switch(pSource->GetClientSoft())
		{
			case SO_CDONKEY:
				pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_CDONKEY);
				break;
			case SO_LMULE:
				pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_LMULE);
				break;
			case SO_SHAREAZA:
				pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_SHAREAZA);
				break;
			case SO_EDONKEYHYBRID:
				pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_EDONKEYHYBRID);
				break;
			case SO_MLDONKEY:
				pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_MLDONKEY);
				break;
			case SO_EMULE:
			case SO_OLDEMULE:
				if(pSource->m_pCredits->GetCurrentIdentState(pSource->GetIP()) != IS_IDENTIFIED)
					pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_SECUREHASH);
				else
					pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_COMPROT);
				break;
			case SO_EDONKEY:
				pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_NORMAL);
				break;
			default:
				pNotify->ti->hIcon = m_ctlUploadList.m_imageList.ExtractIcon(UL_ICON_UNKNOWN);
				break;
		}

		m_ctlUploadList.SetFocus();
		//END Improved Tooltips
	}
	else if (control_id == TRANS_QUEUELIST)
	{
		if (m_ctlQueueList.GetItemCount() < 1)
			return FALSE;

		int sel = GetItemUnderMouse(&m_ctlQueueList);
		if (sel < 0 || sel == 65535)
			return FALSE;

		// build info text and display it
		CUpDownClient* pSource = (CUpDownClient*)m_ctlUploadList.GetItemData(sel);
		in_addr server;
		server.S_un.S_addr = pSource->GetServerIP();

		info.Format(_T("Nickname: %s (UserID: %u)\n")
					_T("Client %s:%d\n")
					_T("Server %s:%d\n")
					_T("AskedCount: %d - AvailablePartCount: %d"),
					pSource->GetUserName(), pSource->GetUserID(),
					pSource->GetFullIP(), pSource->GetUserPort(), 
					inet_ntoa(server), pSource->GetServerPort(),
					pSource->GetAskedCount(), pSource->GetAvailablePartCount());

	}
	pNotify->ti->sTooltip = info;

	EMULE_CATCH

	return TRUE;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	SwitchUploadList() toggles the visibility of the UploadList with the UploadQueueList
void CTransferWnd::SwitchUploadList()
{	
	EMULE_TRY

	switch (m_nActiveWnd)
	{
		case MPW_UPLOADLIST:
		{
			m_nActiveWnd = MPW_UPLOADQUEUELIST;
			m_ctlRollup.SetText(1, GetResString(IDS_ONQUEUE), true);
			m_ctlUploadList.ShowWindow(SW_HIDE);
			m_ctlClientList.ShowWindow(SW_HIDE);
			m_ctlRollup.SetItemClient(1, &m_ctlQueueList);
			m_ctlRollup.Invalidate();
			UpdateQueueFilter();
			break;
		}
		case MPW_UPLOADQUEUELIST:
		{
			m_nActiveWnd = MPW_UPLOADCLIENTLIST;
			CString buffer;
			buffer.Format(" (%i)", m_ctlClientList.GetItemCount());
			m_ctlRollup.SetText(1, GetResString(IDS_CLIENTLIST)+buffer, true);
			m_ctlUploadList.ShowWindow(SW_HIDE);
			m_ctlQueueList.ShowWindow(SW_HIDE);
			m_ctlRollup.SetItemClient(1, &m_ctlClientList);
			m_ctlRollup.Invalidate();
			break;
		}
		case MPW_UPLOADCLIENTLIST:
		{
			m_nActiveWnd = MPW_UPLOADLIST;
			m_ctlRollup.SetText(1, GetResString(IDS_RUP_UPLOADS), true);
			m_ctlQueueList.ShowWindow(SW_HIDE);
			m_ctlClientList.ShowWindow(SW_HIDE);
			m_ctlRollup.SetItemClient(1, &m_ctlUploadList);
			m_ctlRollup.Invalidate();
			break;
		}
		default:
			break;
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Update Known Clients on header when total number of known clients change (triggered in ClientListCtrl)
void CTransferWnd::UpdateKnown()
{
	if(m_nActiveWnd == MPW_UPLOADCLIENTLIST)
	{
		CString buffer;
		buffer.Format(" (%i)", m_ctlClientList.GetItemCount());
		m_ctlRollup.SetText(1, GetResString(IDS_CLIENTLIST)+buffer, true);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Update Applied Filter on header when filter changes (triggered in QueueListCtrl)
void CTransferWnd::UpdateQueueFilter()
{
	if(m_nActiveWnd == MPW_UPLOADQUEUELIST)
	{
		CString buffer = "";
		if(m_ctlQueueList.m_iClientFilter == 1)
			buffer.Format(" (%s)", GetResString(IDS_BANNED));
		else if(m_ctlQueueList.m_iClientFilter == 2)
			buffer.Format(" (%s)", GetResString(IDS_CW_FRIENDS));
		else if(m_ctlQueueList.m_iClientFilter == 3)
			buffer.Format(" (%s)", GetResString(IDS_WITHCREDITS));

		m_ctlRollup.SetText(1, GetResString(IDS_ONQUEUE)+buffer, true);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Localize() loads localized text for the UI resources
void CTransferWnd::Localize()
{	
	EMULE_TRY

	switch(m_nActiveWnd)
	{
		case MPW_UPLOADLIST:
			m_ctlRollup.SetText(1,GetResString(IDS_RUP_UPLOADS), true);
			break;
		case MPW_UPLOADQUEUELIST:
			UpdateQueueFilter();
			break;
		case MPW_UPLOADCLIENTLIST:
			UpdateKnown();
			break;
	}

	//Cax2 - localize the rollup control
	m_ctlRollup.SetText(0,GetResString(IDS_RUP_DOWNLOADS), true);
	m_ctlRollup.SetText(2,GetResString(IDS_RUP_INFO), true);
	if(m_bFirstShow)
	{
		m_bFirstShow = false;
		m_ctlInfoList.SetColumn(g_eMuleApp.m_pGlobPrefs->GetDetailColumnWidth());
	}

	m_ctlDownloadList.Localize();
	m_ctlUploadList.Localize();
	m_ctlQueueList.Localize();
	m_ctlClientList.Localize();
	m_ctlInfoList.Localize();

	CString  strCatTitle = "";

	for (uint8 i = 0; i < CCat::GetNumPredefinedCats(); i++)
	{
		if (i == 0)
		{
			_EnumCategories eCatID = CCat::GetAllCatType();
			strCatTitle = CCat::GetPredefinedCatTitle(eCatID);
	
			if (eCatID != CAT_ALL)
				strCatTitle = _T("[") + strCatTitle + _T("]");
		}
		else
		{
			strCatTitle = CCat::GetPredefinedCatTitle(CCat::GetCatIDByIndex(i));
		}

		EditCatTabLabel(i, strCatTitle);
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	UpdateDownloadHeader() updates the information displayed in the right side of the DownloadList rollup bar
void CTransferWnd::UpdateDownloadHeader()
{	
	EMULE_TRY

	CString strBuffer;

	strBuffer.Format( GetResString(IDS_RUP_DOWNINFO),
					  g_eMuleApp.m_pDownloadQueue->GetFileCount(),
					  g_eMuleApp.m_pDownloadQueue->GetTransferringFiles(),
					  static_cast<double>(g_eMuleApp.m_pDownloadQueue->GetDataRate())/1024.0 );
	m_ctlRollup.SetText(0, strBuffer);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	UpdateUploadHeader() updates the information displayed in the right side of the UploadList rollup bar
void CTransferWnd::UpdateUploadHeader()
{	
	EMULE_TRY

	CString strBuffer;

	strBuffer.Format( GetResString(IDS_RUP_UPINFO),
					  g_eMuleApp.m_pUploadQueue->GetWaitingUserCount(),
						g_eMuleApp.m_pUploadQueue->GetUploadQueueLength(), 
							g_eMuleApp.m_pUploadQueue->GetBanCount(),
								static_cast<double>(g_eMuleApp.m_pUploadQueue->GetDataRate())/1024.0);
	m_ctlRollup.SetText(1, strBuffer);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	UpdateInfoHeader() updates the information displayed in the right side of the InfoList rollup bar
void CTransferWnd::UpdateInfoHeader()
{		
	EMULE_TRY

	CString strInfoHeader = _T("");

	switch (m_ctlInfoList.GetType())
	{	
		case INFOLISTTYPE_SOURCE: 
			strInfoHeader.Format(GetResString(IDS_RUP_INFOUSER), m_ctlInfoList.GetName()); 
			break;
		case INFOLISTTYPE_FILE: 
			strInfoHeader.Format(GetResString(IDS_RUP_INFOFILE), m_ctlInfoList.GetName()); 
			break;
		default: 
			strInfoHeader = "";
			break;
	}
	
	m_ctlRollup.SetText(2, strInfoHeader);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::InitRollupItemHeights()
{	
	EMULE_TRY

	double fItemHeights[3][8];
		
	FILE *f;
	CString fullpath;

	//
	//	Try to open the GUI settings save file
	fullpath.Format(_T("%sgui.dat"), g_eMuleApp.m_pGlobPrefs->GetConfigDir());
	f = _tfopen(fullpath, _T("rb"));	
	
	bool bUseDefault = false;

	//	If we opened it...
	if(f)
	{
		TCHAR cTemp[512];
		TCHAR *pToken;
        TCHAR seps[] = _T("|\n");

		for(int exp = 0; exp < 8; exp++)
		{
		//	Try to read a line from the file. If we can't...
			if(!_fgetts(cTemp, 512, f))
			{
				bUseDefault = true;
				break;
			}

			double fTotalHeight = 0.0;

			//	Look for the next seperator
			pToken = _tcstok(cTemp, seps);
			for(int i = 0; i < 3; i++)
			{
			//	If we couldn't find the expected seperator
				if(!pToken)
				{
					bUseDefault = true;
					//	Terminate the outer loop
					exp = 8;
					break;
				}

			//	Extract the next percentage
				fItemHeights[i][exp] = _tstof(pToken);
//				TRACE("fItemHeights[%d][%d] = %f\r\n", i, exp, _tstof(pToken));
			//	Find the next seperator
				pToken = _tcstok(NULL, seps);

			//	If we somehow read a negative percentage...
				if(fItemHeights[i][exp] < 0)	// this should never happen
				{
					bUseDefault = true;
					//	Terminate both the inner and outer loops
					exp = 8;
					i = 3;
				}
			//	Total up the percentages for this expansion pattern
				fTotalHeight += fItemHeights[i][exp];
			}
			
			//	If the percentages don't total up to 100 somehow...
			if(fTotalHeight >= 101 || fTotalHeight <= 99 && fTotalHeight != 0) // i'm very tolerant ;)
			{
				bUseDefault = true;
				//	Terminate the outer loop
				exp = 8;
			}
		}	

	//
	//	Restore the user's last expansion state
	//

	//	Try to read the next line
		if(!_fgetts(cTemp, 512, f))
			bUseDefault = true;

		if(!bUseDefault)
		{
			pToken = _tcstok(cTemp, seps);
			
			for(int i = 0; i < 3; i++)
			{
				if(!pToken)
				{
					bUseDefault = true;
					i = 3;
				}

				m_ctlRollup.ExpandItem(i, _tstoi(pToken));
				pToken = _tcstok(NULL, seps);
			}
		}
		
		fclose(f);
	}
	//	If there are no saved GUI settings...
	else
		bUseDefault = true;
	
	if(bUseDefault)
	{
		BYTE bExpandedItems; 

		bExpandedItems = 0x00;
		fItemHeights[0][bExpandedItems] = 0;
		fItemHeights[1][bExpandedItems] = 0;
		fItemHeights[2][bExpandedItems] = 0;

		bExpandedItems = 0x01;
		fItemHeights[0][bExpandedItems] = 100;
		fItemHeights[1][bExpandedItems] = 0;
		fItemHeights[2][bExpandedItems] = 0;

		bExpandedItems = 0x02;
		fItemHeights[0][bExpandedItems] = 0;
		fItemHeights[1][bExpandedItems] = 100;
		fItemHeights[2][bExpandedItems] = 0;

		bExpandedItems = 0x03;
		fItemHeights[0][bExpandedItems] = 70;
		fItemHeights[1][bExpandedItems] = 30;
		fItemHeights[2][bExpandedItems] = 0;

		bExpandedItems = 0x04;
		fItemHeights[0][bExpandedItems] = 0;
		fItemHeights[1][bExpandedItems] = 0;
		fItemHeights[2][bExpandedItems] = 100;

		bExpandedItems = 0x05;
		fItemHeights[0][bExpandedItems] = 70;
		fItemHeights[1][bExpandedItems] = 0;
		fItemHeights[2][bExpandedItems] = 30;

		bExpandedItems = 0x06;
		fItemHeights[0][bExpandedItems] = 0;
		fItemHeights[1][bExpandedItems] = 70;
		fItemHeights[2][bExpandedItems] = 30;

		bExpandedItems = 0x07;
		fItemHeights[0][bExpandedItems] = 50;
		fItemHeights[1][bExpandedItems] = 25;
		fItemHeights[2][bExpandedItems] = 25;
	}

	m_ctlRollup.SetItemHeights(0, fItemHeights[0], 8);
	m_ctlRollup.SetItemHeights(1, fItemHeights[1], 8);
	m_ctlRollup.SetItemHeights(2, fItemHeights[2], 8);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::SaveRollupItemHeights()
{	
	EMULE_TRY

	FILE *f;
	CString fullpath; // i_a

	fullpath.Format(_T("%sgui.dat"), g_eMuleApp.m_pGlobPrefs->GetConfigDir());
	f = _tfopen(fullpath, _T("wb"));	

	if(f)
	{
		for(int exp = 0; exp < 8; exp++)
		{	
			double f1,f2,f3;

			f1 = m_ctlRollup.GetItem(0)->pSizes[exp];
			f2 = m_ctlRollup.GetItem(1)->pSizes[exp];
			f3 = m_ctlRollup.GetItem(2)->pSizes[exp];
	
			// get rid off some rounding errors: ///
			if(f3)
				f3 = f1 ? (f2 ? (100 - f1 - f2) : (100 - f1)) : (100 - f2);
			else if(f2)
				f2 = 100 - f1;				
			////////////////////////////////////////

			fprintf(f, "%f|%f|%f\n", f1, f2, f3);
		}
		fprintf( f, "%d|%d|%d\n",
				 m_ctlRollup.GetItem(0)->pHeader->IsExpanded(),
				 m_ctlRollup.GetItem(1)->pHeader->IsExpanded(),
				 m_ctlRollup.GetItem(2)->pHeader->IsExpanded() );
		fclose(f);
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CTransferWnd::OnCommand(WPARAM wParam, LPARAM lParam)
{	
	if (wParam >= MP_CAT_SET_0 && wParam <= MP_CAT_SET_LAST) 
	{
		EnumCategories		eCatID = static_cast<_EnumCategories>(static_cast<int>(CAT_PREDEFINED) + (wParam - MP_CAT_SET_0));

		CCat::SetAllCatType(eCatID);
		m_nLastCatTT = -1;
		m_ctlDLTabs.SetCurSel(0);
		m_ctlDownloadList.ChangeCategoryByIndex(0);
		if (eCatID == CAT_ALL)
			EditCatTabLabel(0, CCat::GetPredefinedCatTitle(CCat::GetAllCatType()));
		else
			EditCatTabLabel(0, _T("[")+CCat::GetPredefinedCatTitle(CCat::GetAllCatType())+_T("]"));
		return TRUE;
	}
	if (wParam >= MP_SHOWPREDEFINEDCAT_0 && wParam <= MP_SHOWPREDEFINEDCAT_LAST)
	{
		uint8				iCatPos = wParam - MP_SHOWPREDEFINEDCAT_0;
		EnumCategories		eCatID = static_cast<_EnumCategories>(iCatPos + static_cast<int>(CAT_PREDEFINED));
		int					iCatIndex = CCat::GetCatIndexByID(eCatID);

	//	If the predefined cat isn't in...
		if (iCatIndex == -1)
		{
			AddPredefinedCategory(eCatID);
			g_eMuleApp.m_pGlobPrefs->SaveCats();
		}
		else
		{
			m_nLastCatTT = -1;
			CCat::RemoveCatByIndex(iCatIndex);
			m_ctlDLTabs.DeleteItem(iCatIndex);
			m_ctlDLTabs.SetCurSel(0);
			m_ctlDownloadList.ChangeCategoryByID(CAT_ALL);
			g_eMuleApp.m_pGlobPrefs->SaveCats();
		}
		UpdateCatTabTitles();
		return TRUE;
	}

	switch (wParam)
	{
		case USRMSG_SWITCHUPLOADLIST:
			SwitchUploadList();
			break;

		case USRMSG_CLEARCOMPLETED:
			g_eMuleApp.m_pDownloadList->ClearCompleted(CAT_NONE);
			break;

		case MP_CAT_ADD:
		{
			m_nLastCatTT = -1;
			int newindex = AddCategory("?", g_eMuleApp.m_pGlobPrefs->GetIncomingDir(), "", "", true);
			CCatDialog dialog(newindex);

			if (dialog.DoModal() == IDCANCEL)
			{
				CCat::RemoveCatByIndex(newindex);
				m_ctlDLTabs.DeleteItem(newindex);
				m_ctlDLTabs.SetCurSel(0);
				m_ctlDownloadList.ChangeCategoryByIndex(0);
				g_eMuleApp.m_pGlobPrefs->SaveCats();
				if (CCat::GetNumCats() == 1) 
				{
					CCat::SetAllCatType(CAT_ALL);
				}
				g_eMuleApp.m_pdlgEmule->m_dlgSearch.UpdateCatTabs();
			}
			else
			{
				g_eMuleApp.m_pdlgEmule->m_dlgSearch.UpdateCatTabs();
				EditCatTabLabel(newindex, CCat::GetCatByIndex(newindex)->GetTitle());
				g_eMuleApp.m_pGlobPrefs->SaveCats();
			}
			break;
		}

		case MP_CAT_EDIT:
		{
			m_nLastCatTT = -1;

			CCatDialog		dialog(m_iTabRightClickIndex);

			dialog.DoModal();

			CString csName;

			csName.Format("%s", CCat::GetCatByIndex(m_iTabRightClickIndex)->GetTitle());
			EditCatTabLabel(m_iTabRightClickIndex,csName);
			g_eMuleApp.m_pdlgEmule->m_dlgSearch.UpdateCatTabs();
			g_eMuleApp.m_pGlobPrefs->SaveCats();
			break;
		}
		case MP_CAT_REMOVE:
		{
			m_nLastCatTT = -1;
			g_eMuleApp.m_pDownloadQueue->ResetCatParts(m_iTabRightClickIndex);
			CCat::RemoveCatByIndex(m_iTabRightClickIndex);
			m_ctlDLTabs.DeleteItem(m_iTabRightClickIndex);
			m_ctlDLTabs.SetCurSel(0);
			m_ctlDownloadList.ChangeCategoryByID(CAT_ALL);
			g_eMuleApp.m_pGlobPrefs->SaveCats();
			if (CCat::GetNumCats() == 1) 
			{
				CCat::SetAllCatType(CAT_ALL);
			}
			g_eMuleApp.m_pdlgEmule->m_dlgSearch.UpdateCatTabs();
			break;
		}
		case MP_PRIOLOW:
		{
			g_eMuleApp.m_pDownloadQueue->SetCatPrio(m_iTabRightClickIndex,PR_LOW);
			break;
		}
		case MP_PRIONORMAL:
		{
			g_eMuleApp.m_pDownloadQueue->SetCatPrio(m_iTabRightClickIndex,PR_NORMAL);
			break;
		}
		case MP_PRIOHIGH:
		{
			g_eMuleApp.m_pDownloadQueue->SetCatPrio(m_iTabRightClickIndex,PR_HIGH);
			break;
		}
		case MP_PRIOAUTO:
		{
			g_eMuleApp.m_pDownloadQueue->SetCatPrio(m_iTabRightClickIndex,PR_AUTO);
			break;
		}
		case MP_PAUSE:
		{
			g_eMuleApp.m_pDownloadQueue->SetCatStatus(m_iTabRightClickIndex,MP_PAUSE);
			break;
		}
		case MP_STOP:
		{
			g_eMuleApp.m_pDownloadQueue->SetCatStatus(m_iTabRightClickIndex,MP_STOP);
			break;
		}
		case MP_CANCEL:
		{
			if (AfxMessageBox(GetResString(IDS_Q_CANCELDL),MB_ICONQUESTION|MB_YESNO) == IDYES)
			{	
				g_eMuleApp.m_pDownloadQueue->SetCatStatus(m_iTabRightClickIndex,MP_CANCEL);
			}
			break;
		}
		case MP_RESUME:
		{
			g_eMuleApp.m_pDownloadQueue->SetCatStatus(m_iTabRightClickIndex,MP_RESUME);
			break;
		}
		case MP_RESUMENEXT:
		{
			g_eMuleApp.m_pDownloadQueue->StartNextFile(CCat::GetCatIDByIndex(m_iTabRightClickIndex));
			break;
		}
		default: 
			break;
	}
	
	return CResizableDialog::OnCommand(wParam, lParam);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	GetTabUnderMouse() returns the index of the category tab at point 'point' or -1 if there is none.
int CTransferWnd::GetTabUnderMouse(CPoint* point) 
{	
	TCHITTESTINFO hitinfo;
	CRect rect;

	m_ctlDLTabs.GetWindowRect(&rect);
	point->Offset(0-rect.left,0-rect.top);
	hitinfo.pt = *point;

	if(m_ctlDLTabs.GetItemRect( 0, &rect ))
	{
		if(hitinfo.pt.y< rect.top+30 && hitinfo.pt.y >rect.top-30)
		{	
			hitinfo.pt.y = rect.top;
		}
	}

	// Find the destination tab...
	unsigned int		nTab = m_ctlDLTabs.HitTest(&hitinfo);

	if(hitinfo.flags != TCHT_NOWHERE)
		return nTab;
	else 
		return -1;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::UpdateTabToolTips(int tab) 
{	
	uint8 i;

	if(tab==-1) 
	{
		for (i=0;i<m_pttDlTabToolTips->GetToolCount();i++)
			m_pttDlTabToolTips->DelTool(&m_ctlDLTabs,i+1);

		for (i = 0; i < m_ctlDLTabs.GetItemCount(); i++)
		{
			CRect r;
			m_ctlDLTabs.GetItemRect(i, &r);
			VERIFY(m_pttDlTabToolTips->AddTool(&m_ctlDLTabs, GetTabStatistic(i), &r, i+1));
		}
	} 
	else 
	{
		CRect r;
		m_ctlDLTabs.GetItemRect(tab, &r);

		m_pttDlTabToolTips->DelTool(&m_ctlDLTabs,tab+1);
		VERIFY(m_pttDlTabToolTips->AddTool(&m_ctlDLTabs, GetTabStatistic(tab), &r, tab+1));
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CString CTransferWnd::GetTabStatistic(uint8 tab) 
{	
	uint16 count,dwl;
	count= dwl = 0;
	double speed = 0.0;
	uint64 size = 0;
	uint64 trsize = 0;
	CPartFile* cur_file;

	for(int i=0;i<g_eMuleApp.m_pDownloadQueue->GetFileCount();i++) 
	{
		cur_file=g_eMuleApp.m_pDownloadQueue->GetFileByIndex(i);
		
		if(cur_file != 0) 
		{
			if(CCat::FileBelongsToGivenCat(cur_file, CCat::GetCatIDByIndex(tab))) 
			{
				count++;
				if(cur_file->GetTransferringSrcCount() > 0) 
					dwl++;
				speed += cur_file->GetDataRate() / 1024.0f;
				size += cur_file->GetFileSize();
				trsize += cur_file->GetCompletedSize();
			}
		}
	}

	CString strTitle;
	strTitle.Format("%s: %i/%i\n%s: %.1f %s\n%s: %s/%s",
		GetResString(IDS_DOWNLOADING), dwl, count,GetResString(IDS_DL_SPEED) ,speed,GetResString(IDS_KBYTESEC),
		GetResString(IDS_DL_SIZE),CastItoXBytes(trsize),CastItoXBytes(size) );
	return strTitle;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	OnTcnSelchangeDltab() is the message handler for selection changes in the category tab
void CTransferWnd::OnTcnSelchangeDltab(NMHDR *pNMHDR, LRESULT *pResult)
{	
	uint8		catIndex;

	catIndex = m_ctlDLTabs.GetCurSel();
	m_ctlDownloadList.ChangeCategoryByIndex(catIndex);
	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	OnNMRClickDltab() is the right-click message handler for the tab control.
// Ornis' download categories
void CTransferWnd::OnNMRClickDltab(NMHDR *pNMHDR, LRESULT *pResult)
{
//	Popup menu for the category tabs
	CTitleMenu menu;
	POINT point;

	::GetCursorPos(&point);

	CPoint pt(point);

	m_iTabRightClickIndex = GetTabUnderMouse(&pt);

	UINT		iPredefinedCatActionFlag;
	UINT		iIsAllOrUserFlag;
	int			iNumPredefinedCats = CCat::GetNumPredefinedCats();

	iPredefinedCatActionFlag = (m_iTabRightClickIndex < iNumPredefinedCats) ? MF_GRAYED : MF_STRING;
	iIsAllOrUserFlag = ((m_iTabRightClickIndex < iNumPredefinedCats) && !(m_iTabRightClickIndex == 0 && CCat::GetAllCatType() == CAT_ALL))? MF_GRAYED : MF_STRING;

	CMenu		m_viewMenu;

	m_viewMenu.CreateMenu();

	CMenu		m_catMenu;

	m_catMenu.CreateMenu();

	CMenu		m_priorityMenu;

	m_priorityMenu.CreateMenu();
	m_priorityMenu.AppendMenu(MF_STRING,MP_PRIOLOW,GetResString(IDS_PRIOLOW));
	m_priorityMenu.AppendMenu(MF_STRING,MP_PRIONORMAL,GetResString(IDS_PRIONORMAL));
	m_priorityMenu.AppendMenu(MF_STRING,MP_PRIOHIGH, GetResString(IDS_PRIOHIGH));
	m_priorityMenu.AppendMenu(MF_STRING,MP_PRIOAUTO, GetResString(IDS_PRIOAUTO));

	menu.CreatePopupMenu();
	menu.AddMenuTitle(GetResString(IDS_CAT));

	if (m_iTabRightClickIndex == 0)
	{
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0,GetResString(IDS_CAT_ALL));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+1,GetResString(IDS_CAT_UNCATEGORIZED));
		m_viewMenu.AppendMenu(MF_SEPARATOR);
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+2,GetResString(IDS_CAT_INCOMPLETE));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+3,GetResString(IDS_CAT_COMPLETED));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+4,GetResString(IDS_CAT_WAITING));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+5,GetResString(IDS_CAT_DOWNLOADING));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+6,GetResString(IDS_CAT_ERRONEOUS));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+7,GetResString(IDS_CAT_PAUSED));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+8,GetResString(IDS_CAT_STOPPED));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+9,GetResString(IDS_CAT_STALLED));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+10,GetResString(IDS_CAT_ACTIVE));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+11,GetResString(IDS_CAT_INACTIVE));
		m_viewMenu.AppendMenu(MF_SEPARATOR);
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+12,GetResString(IDS_CAT_VIDEO));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+13,GetResString(IDS_CAT_AUDIO));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+14,GetResString(IDS_CAT_ARCHIVES));
		m_viewMenu.AppendMenu(MF_STRING,MP_CAT_SET_0+15,GetResString(IDS_CAT_CDIMAGES));
		
		m_viewMenu.CheckMenuItem(MP_CAT_SET_0 + CCat::GetAllCatType() - CAT_PREDEFINED, MF_CHECKED | MF_BYCOMMAND);

		menu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_viewMenu.m_hMenu, GetResString(IDS_CHANGECATVIEW));
	}

	if (m_iTabRightClickIndex < iNumPredefinedCats)
	{
		for (int i = 0; i < CAT_TOTALPREDEFINEDCATS; i++)
		{
		//	Check to see if the cat has a tab and check the menu item if so
			int		catIndex = CCat::GetCatIndexByID(static_cast<_EnumCategories>(static_cast<int>(CAT_PREDEFINED) + i));
			UINT	checkFlag = 0;

			checkFlag = (catIndex == -1) ? MF_UNCHECKED : MF_CHECKED;
			if (i == 0)
				checkFlag |= MF_GRAYED;
		
		//	Add the 'i'th predefined category title
			m_catMenu.AppendMenu( MF_STRING | checkFlag,
								  MP_SHOWPREDEFINEDCAT_0 + i,
								  CCat::GetPredefinedCatTitle(static_cast<_EnumCategories>(static_cast<int>(CAT_PREDEFINED) + i)) );

		//	Add a seperator after the last of the status categories.
			if (CAT_PREDEFINED + i == CAT_LASTSTATUSCAT)
			{
				m_catMenu.AppendMenu(MF_SEPARATOR);
			}
		}
		
		menu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)m_catMenu.m_hMenu, GetResString(IDS_CAT_SHOWSTATUSTAB));
		menu.AppendMenu(MF_SEPARATOR);
	}

	menu.AppendMenu(MF_STRING,MP_CAT_ADD,GetResString(IDS_CAT_ADD));
	menu.AppendMenu(iPredefinedCatActionFlag,MP_CAT_EDIT,GetResString(IDS_CAT_EDIT));
	menu.AppendMenu(iPredefinedCatActionFlag,MP_CAT_REMOVE, GetResString(IDS_CAT_REMOVE));
	menu.AppendMenu(MF_SEPARATOR);
	menu.AppendMenu(iIsAllOrUserFlag|MF_POPUP,(UINT_PTR)m_priorityMenu.m_hMenu, GetResString(IDS_PRIORITY) );

	menu.AppendMenu(MF_STRING,MP_CANCEL,GetResString(IDS_MAIN_BTN_CANCEL));
	menu.AppendMenu(MF_STRING,MP_STOP, GetResString(IDS_DL_STOP));
	menu.AppendMenu(MF_STRING,MP_PAUSE, GetResString(IDS_DL_PAUSE));
	menu.AppendMenu(MF_STRING,MP_RESUME, GetResString(IDS_DL_RESUME));
	menu.AppendMenu(MF_STRING,MP_RESUMENEXT, GetResString(IDS_DL_RESUMENEXT));
	
	menu.TrackPopupMenu(TPM_LEFTALIGN |TPM_RIGHTBUTTON, point.x, point.y, this);
	VERIFY( m_priorityMenu.DestroyMenu() );
	VERIFY( m_catMenu.DestroyMenu() );
	VERIFY(menu.DestroyMenu());

	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::OnLvnBeginDrag(NMHDR *pNMHDR, LRESULT *pResult)
{	
	int iSel = m_ctlDownloadList.GetSelectionMark();

	if(iSel==-1) 
		return;

	CMuleCtrlItem	   *pItem = reinterpret_cast<CMuleCtrlItem*>(m_ctlDownloadList.GetItemData(iSel));
	CPartFileDLItem	   *pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);

	if (pFileItem == NULL)
		return;
	
	m_bIsDragging = true;

	POINT pt;

	::GetCursorPos(&pt);
	
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	m_nDragIndex = pNMLV->iItem;
	m_pDragImage = m_ctlDownloadList.CreateDragImage(m_ctlDownloadList.GetSelectionMark(),&pt);
    m_pDragImage->BeginDrag(0, CPoint(0,0));
    m_pDragImage->DragEnter(GetDesktopWindow(), pNMLV->ptAction);
    SetCapture();
	m_nTabDropIndex = -1;

	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::OnMouseMove(UINT nFlags, CPoint point)
{	
	if(!(nFlags & MK_LBUTTON)) 
		m_bIsDragging = false;


	if(m_bIsDragging)
	{
		CPoint pt(point);           //get our current mouse coordinates

		ClientToScreen(&pt);        //convert to screen coordinates
		
		m_nTabDropIndex = GetTabUnderMouse(&pt);
		m_ctlDLTabs.SetCurSel(m_nTabDropIndex);
		m_ctlDLTabs.Invalidate();
	
		::GetCursorPos(&pt);
		pt.y -= 10;

		m_pDragImage->DragMove(pt); //move the drag image to those coordinates
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::OnLButtonUp(UINT iFlags, CPoint point)
{	
	if (m_bIsDragging)
	{
		ReleaseCapture();
		m_bIsDragging = false;

		m_pDragImage->DragLeave(GetDesktopWindow());
		m_pDragImage->EndDrag();
		delete m_pDragImage;
		
	//	If the cursor is over a tab and the current tab is a predefined cat
		if ( m_nTabDropIndex >= CCat::GetNumPredefinedCats()
		 && ( m_ctlDownloadList.GetCurTabIndex() < CCat::GetNumPredefinedCats()
		   || ( m_ctlDownloadList.GetCurTabIndex() >= CCat::GetNumPredefinedCats()
		     && m_nTabDropIndex != m_ctlDownloadList.GetCurTabIndex()) ) )
		{
			CPartFile	   *pPartFile;
			int				index = -1; 
			POSITION		pos = m_ctlDownloadList.GetFirstSelectedItemPosition(); 

			while (pos != NULL) 
			{ 
				index = m_ctlDownloadList.GetNextSelectedItem(pos); 
				if (index > -1) 
				{
					CMuleCtrlItem	*pItem = reinterpret_cast<CMuleCtrlItem*>(m_ctlDownloadList.GetItemData(index));
					CPartFileDLItem	*pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);

					if (pFileItem != NULL)
					{
						pPartFile = pFileItem->GetFile();
						pPartFile->SetCatID(CCat::GetCatIDByIndex(m_nTabDropIndex));
					}
				} 
			}

			m_ctlDLTabs.SetCurSel(m_ctlDownloadList.GetCurTabIndex());

			//if (m_ctlDLTabs.GetCurSel() > CCat::GetNumPredefinedCats())
			m_ctlDownloadList.ChangeCategoryByIndex(m_ctlDLTabs.GetCurSel());

			UpdateCatTabTitles();
		} 
		else
		{
			m_ctlDLTabs.SetCurSel(m_ctlDownloadList.GetCurTabIndex());
		}
		m_ctlDownloadList.Invalidate();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::OnDblClickDltab()
{	
	POINT point;

	::GetCursorPos(&point);

	CPoint pt(point);
	int tab = GetTabUnderMouse(&pt);

	if (tab < CCat::GetNumPredefinedCats())
		return;
	m_iTabRightClickIndex = tab;
	OnCommand(MP_CAT_EDIT,0);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	UpdateCatTabTitles() updates the tab text to reflect the current category titles and, incidentally,
//		updates the file count information displayed on the tab.
void CTransferWnd::UpdateCatTabTitles() 
{	
//	For each tab...
	for (uint8 i = 0; i < m_ctlDLTabs.GetItemCount(); i++)
	{	
		CString		strCatTitle;

		if (i == 0)
		{
			uint8		iCatID = CCat::GetAllCatType();

			strCatTitle = CCat::GetPredefinedCatTitle(CCat::GetAllCatType());
			if (iCatID != CAT_ALL)
				strCatTitle = _T("[") + strCatTitle + _T("]");
		}
		else
		{
			strCatTitle = CCat::GetCatByIndex(i)->GetTitle();
		}
	//	If it's the "All" tab change the title to reflect the current All category selection.
	//	If not, change the title to reflect the current category title
		EditCatTabLabel(i, strCatTitle);
	}
	UpdateTabToolTips();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	EditCatTabLabel() changes the label of tab 'index' to 'newlabel' (with additional file count info if the
//		"Show Category Tab Info" preference is set)
void CTransferWnd::EditCatTabLabel(int index,CString newlabel) 
{	
	TCITEM tabitem;

	tabitem.mask = TCIF_PARAM;
	m_ctlDLTabs.GetItem(index,&tabitem);
	tabitem.mask = TCIF_TEXT;

	if (g_eMuleApp.m_pGlobPrefs->ShowCatTabInfo())
	{
		CDownloadList::PartFileVector	*pvecPartFiles; 
		CPartFile* pPartFile;
		uint16	iTotalCount = 0;
		uint16	iDownloading = 0;

	//	Count the number of files in the DownloadQueue belonging to the
	//		'index'th category and the number of those currently downloading.
	//
		if (pvecPartFiles = g_eMuleApp.m_pDownloadList->GetFiles())
		{
			for(unsigned int i = 0; i < pvecPartFiles->size(); i++) 
			{
				pPartFile = (*pvecPartFiles)[i];

				if (pPartFile == NULL)
					continue;

				if (CCat::FileBelongsToGivenCat(pPartFile,CCat::GetCatIDByIndex(index)))
				{
					iTotalCount++;
					if(pPartFile->GetTransferringSrcCount() > 0) 
						iDownloading++;
				}
			}
		}

		delete pvecPartFiles;
		pvecPartFiles = NULL;

	//	Append the appropriate information to the tab label
	//
		CString strTitle=newlabel;

		if (!CCat::GetCatByIndex(index)->IsPredefined())
		{
			newlabel.Format("%s %i/%i",strTitle,iDownloading,iTotalCount);
		}
		else
		{
		//	We don't really need a download count on predefined cats.
			newlabel.Format("%s %i",strTitle,iTotalCount);
		}
	}

	tabitem.pszText = newlabel.LockBuffer();
	m_ctlDLTabs.SetItem(index,&tabitem);
	newlabel.UnlockBuffer();
	m_ctlDLTabs.Invalidate();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CTransferWnd::AddCategory( CString strNewTitle,CString strNewIncoming,CString strNewComment, 
							   CString strNewAutoCatExt, bool bAddTab)
{
	CCat		*pNewCat = new CCat(strNewTitle,strNewIncoming,strNewComment,strNewAutoCatExt);

	int		iIndex = CCat::AddCat(pNewCat);

	if (bAddTab) 
		m_ctlDLTabs.InsertItem(iIndex,strNewTitle);

	m_ctlDLTabs.Invalidate();

	return iIndex;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CTransferWnd::AddPredefinedCategory(EnumCategories ePredefinedCatID, bool bAddTab/*=true*/)
{
	CCat	*pNewCat = new CCat(ePredefinedCatID);

	int		iIndex = CCat::AddPredefinedCat(pNewCat);

	if (bAddTab) 
		m_ctlDLTabs.InsertItem(iIndex,pNewCat->GetTitle());

	m_ctlDLTabs.Invalidate();

	return iIndex;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::OnTabMovement(NMHDR *pNMHDR, LRESULT *pResult) 
{	
	UINT	from = m_ctlDLTabs.GetLastMovementSource();
	UINT	to = m_ctlDLTabs.GetLastMovementDestination();
	uint8	iNumPredefinedCats = CCat::GetNumPredefinedCats();

	if (from < iNumPredefinedCats || to < iNumPredefinedCats || from == to-1)
		return;
//
//	Do the reorder
//

//	Rearrange the cat-map
	if (!CCat::MoveCat(from,to))
		return;

//	Rearrange the tab control itself
	m_ctlDLTabs.ReorderTab(from,to);

	UpdateCatTabTitles();
	g_eMuleApp.m_pdlgEmule->m_dlgSearch.UpdateCatTabs();

	if (to > from) 
	{
		--to;
	}
	m_ctlDLTabs.SetCurSel(to);
	m_ctlDownloadList.ChangeCategoryByIndex(to);
	m_ctlDLTabs.Invalidate();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CTransferWnd::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	NMHDR* pNMHDR = (NMHDR*)lParam;

	if (pNMHDR->hwndFrom == m_ctlDLTabs.GetSafeHwnd())
	{
		switch(pNMHDR->code)
		{
			case NM_RCLICK:
				OnNMRClickDltab(pNMHDR, pResult);
				break;
			case NM_DBLCLK:
			case WM_LBUTTONDBLCLK:
				OnDblClickDltab();
				break;
			case TCN_SELCHANGE:
				OnTcnSelchangeDltab(pNMHDR, pResult);
				break;
			case NM_TABMOVED:
				OnTabMovement(pNMHDR, pResult);
				break;
		}
	}
	else if(pNMHDR->hwndFrom == m_ctlDownloadList.GetSafeHwnd())
	{
		switch(pNMHDR->code)
		{
			case LVN_BEGINDRAG:
				OnLvnBeginDrag(pNMHDR, pResult);
				break;
		}
	}

	return CResizableDialog::OnNotify(wParam, lParam, pResult);
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
